#include "cpu.h"
#include "cpu2.h"
#include "cpu3.h"
#include "mem.h"

// Gameboy CPU instruction set(0x00 - 0xff)

// Ӂ@ERST ߂GBSpɕύXĂ܂

//---------------------------------------------------------------------------
ST_CPU_EXEC_TABLE CpuExecTable[0x100] = {
	{ (void*)CpuExec0x00 },
	{ (void*)CpuExec0x01 },
	{ (void*)CpuExec0x02 },
	{ (void*)CpuExec0x03 },
	{ (void*)CpuExec0x04 },
	{ (void*)CpuExec0x05 },
	{ (void*)CpuExec0x06 },
	{ (void*)CpuExec0x07 },
	{ (void*)CpuExec0x08 },
	{ (void*)CpuExec0x09 },
	{ (void*)CpuExec0x0a },
	{ (void*)CpuExec0x0b },
	{ (void*)CpuExec0x0c },
	{ (void*)CpuExec0x0d },
	{ (void*)CpuExec0x0e },
	{ (void*)CpuExec0x0f },
	{ (void*)CpuExec0x10 },
	{ (void*)CpuExec0x11 },
	{ (void*)CpuExec0x12 },
	{ (void*)CpuExec0x13 },
	{ (void*)CpuExec0x14 },
	{ (void*)CpuExec0x15 },
	{ (void*)CpuExec0x16 },
	{ (void*)CpuExec0x17 },
	{ (void*)CpuExec0x18 },
	{ (void*)CpuExec0x19 },
	{ (void*)CpuExec0x1a },
	{ (void*)CpuExec0x1b },
	{ (void*)CpuExec0x1c },
	{ (void*)CpuExec0x1d },
	{ (void*)CpuExec0x1e },
	{ (void*)CpuExec0x1f },
	{ (void*)CpuExec0x20 },
	{ (void*)CpuExec0x21 },
	{ (void*)CpuExec0x22 },
	{ (void*)CpuExec0x23 },
	{ (void*)CpuExec0x24 },
	{ (void*)CpuExec0x25 },
	{ (void*)CpuExec0x26 },
	{ (void*)CpuExec0x27 },
	{ (void*)CpuExec0x28 },
	{ (void*)CpuExec0x29 },
	{ (void*)CpuExec0x2a },
	{ (void*)CpuExec0x2b },
	{ (void*)CpuExec0x2c },
	{ (void*)CpuExec0x2d },
	{ (void*)CpuExec0x2e },
	{ (void*)CpuExec0x2f },
	{ (void*)CpuExec0x30 },
	{ (void*)CpuExec0x31 },
	{ (void*)CpuExec0x32 },
	{ (void*)CpuExec0x33 },
	{ (void*)CpuExec0x34 },
	{ (void*)CpuExec0x35 },
	{ (void*)CpuExec0x36 },
	{ (void*)CpuExec0x37 },
	{ (void*)CpuExec0x38 },
	{ (void*)CpuExec0x39 },
	{ (void*)CpuExec0x3a },
	{ (void*)CpuExec0x3b },
	{ (void*)CpuExec0x3c },
	{ (void*)CpuExec0x3d },
	{ (void*)CpuExec0x3e },
	{ (void*)CpuExec0x3f },
	{ (void*)CpuExec0x40 },
	{ (void*)CpuExec0x41 },
	{ (void*)CpuExec0x42 },
	{ (void*)CpuExec0x43 },
	{ (void*)CpuExec0x44 },
	{ (void*)CpuExec0x45 },
	{ (void*)CpuExec0x46 },
	{ (void*)CpuExec0x47 },
	{ (void*)CpuExec0x48 },
	{ (void*)CpuExec0x49 },
	{ (void*)CpuExec0x4a },
	{ (void*)CpuExec0x4b },
	{ (void*)CpuExec0x4c },
	{ (void*)CpuExec0x4d },
	{ (void*)CpuExec0x4e },
	{ (void*)CpuExec0x4f },
	{ (void*)CpuExec0x50 },
	{ (void*)CpuExec0x51 },
	{ (void*)CpuExec0x52 },
	{ (void*)CpuExec0x53 },
	{ (void*)CpuExec0x54 },
	{ (void*)CpuExec0x55 },
	{ (void*)CpuExec0x56 },
	{ (void*)CpuExec0x57 },
	{ (void*)CpuExec0x58 },
	{ (void*)CpuExec0x59 },
	{ (void*)CpuExec0x5a },
	{ (void*)CpuExec0x5b },
	{ (void*)CpuExec0x5c },
	{ (void*)CpuExec0x5d },
	{ (void*)CpuExec0x5e },
	{ (void*)CpuExec0x5f },
	{ (void*)CpuExec0x60 },
	{ (void*)CpuExec0x61 },
	{ (void*)CpuExec0x62 },
	{ (void*)CpuExec0x63 },
	{ (void*)CpuExec0x64 },
	{ (void*)CpuExec0x65 },
	{ (void*)CpuExec0x66 },
	{ (void*)CpuExec0x67 },
	{ (void*)CpuExec0x68 },
	{ (void*)CpuExec0x69 },
	{ (void*)CpuExec0x6a },
	{ (void*)CpuExec0x6b },
	{ (void*)CpuExec0x6c },
	{ (void*)CpuExec0x6d },
	{ (void*)CpuExec0x6e },
	{ (void*)CpuExec0x6f },
	{ (void*)CpuExec0x70 },
	{ (void*)CpuExec0x71 },
	{ (void*)CpuExec0x72 },
	{ (void*)CpuExec0x73 },
	{ (void*)CpuExec0x74 },
	{ (void*)CpuExec0x75 },
	{ (void*)CpuExec0x76 },
	{ (void*)CpuExec0x77 },
	{ (void*)CpuExec0x78 },
	{ (void*)CpuExec0x79 },
	{ (void*)CpuExec0x7a },
	{ (void*)CpuExec0x7b },
	{ (void*)CpuExec0x7c },
	{ (void*)CpuExec0x7d },
	{ (void*)CpuExec0x7e },
	{ (void*)CpuExec0x7f },
	{ (void*)CpuExec0x80 },
	{ (void*)CpuExec0x81 },
	{ (void*)CpuExec0x82 },
	{ (void*)CpuExec0x83 },
	{ (void*)CpuExec0x84 },
	{ (void*)CpuExec0x85 },
	{ (void*)CpuExec0x86 },
	{ (void*)CpuExec0x87 },
	{ (void*)CpuExec0x88 },
	{ (void*)CpuExec0x89 },
	{ (void*)CpuExec0x8a },
	{ (void*)CpuExec0x8b },
	{ (void*)CpuExec0x8c },
	{ (void*)CpuExec0x8d },
	{ (void*)CpuExec0x8e },
	{ (void*)CpuExec0x8f },
	{ (void*)CpuExec0x90 },
	{ (void*)CpuExec0x91 },
	{ (void*)CpuExec0x92 },
	{ (void*)CpuExec0x93 },
	{ (void*)CpuExec0x94 },
	{ (void*)CpuExec0x95 },
	{ (void*)CpuExec0x96 },
	{ (void*)CpuExec0x97 },
	{ (void*)CpuExec0x98 },
	{ (void*)CpuExec0x99 },
	{ (void*)CpuExec0x9a },
	{ (void*)CpuExec0x9b },
	{ (void*)CpuExec0x9c },
	{ (void*)CpuExec0x9d },
	{ (void*)CpuExec0x9e },
	{ (void*)CpuExec0x9f },
	{ (void*)CpuExec0xa0 },
	{ (void*)CpuExec0xa1 },
	{ (void*)CpuExec0xa2 },
	{ (void*)CpuExec0xa3 },
	{ (void*)CpuExec0xa4 },
	{ (void*)CpuExec0xa5 },
	{ (void*)CpuExec0xa6 },
	{ (void*)CpuExec0xa7 },
	{ (void*)CpuExec0xa8 },
	{ (void*)CpuExec0xa9 },
	{ (void*)CpuExec0xaa },
	{ (void*)CpuExec0xab },
	{ (void*)CpuExec0xac },
	{ (void*)CpuExec0xad },
	{ (void*)CpuExec0xae },
	{ (void*)CpuExec0xaf },
	{ (void*)CpuExec0xb0 },
	{ (void*)CpuExec0xb1 },
	{ (void*)CpuExec0xb2 },
	{ (void*)CpuExec0xb3 },
	{ (void*)CpuExec0xb4 },
	{ (void*)CpuExec0xb5 },
	{ (void*)CpuExec0xb6 },
	{ (void*)CpuExec0xb7 },
	{ (void*)CpuExec0xb8 },
	{ (void*)CpuExec0xb9 },
	{ (void*)CpuExec0xba },
	{ (void*)CpuExec0xbb },
	{ (void*)CpuExec0xbc },
	{ (void*)CpuExec0xbd },
	{ (void*)CpuExec0xbe },
	{ (void*)CpuExec0xbf },
	{ (void*)CpuExec0xc0 },
	{ (void*)CpuExec0xc1 },
	{ (void*)CpuExec0xc2 },
	{ (void*)CpuExec0xc3 },
	{ (void*)CpuExec0xc4 },
	{ (void*)CpuExec0xc5 },
	{ (void*)CpuExec0xc6 },
	{ (void*)CpuExec0xc7 },
	{ (void*)CpuExec0xc8 },
	{ (void*)CpuExec0xc9 },
	{ (void*)CpuExec0xca },
	{ (void*)CpuExec0xcb },
	{ (void*)CpuExec0xcc },
	{ (void*)CpuExec0xcd },
	{ (void*)CpuExec0xce },
	{ (void*)CpuExec0xcf },
	{ (void*)CpuExec0xd0 },
	{ (void*)CpuExec0xd1 },
	{ (void*)CpuExec0xd2 },
	{ (void*)CpuExec0xd3 },
	{ (void*)CpuExec0xd4 },
	{ (void*)CpuExec0xd5 },
	{ (void*)CpuExec0xd6 },
	{ (void*)CpuExec0xd7 },
	{ (void*)CpuExec0xd8 },
	{ (void*)CpuExec0xd9 },
	{ (void*)CpuExec0xda },
	{ (void*)CpuExec0xdb },
	{ (void*)CpuExec0xdc },
	{ (void*)CpuExec0xdd },
	{ (void*)CpuExec0xde },
	{ (void*)CpuExec0xdf },
	{ (void*)CpuExec0xe0 },
	{ (void*)CpuExec0xe1 },
	{ (void*)CpuExec0xe2 },
	{ (void*)CpuExec0xe3 },
	{ (void*)CpuExec0xe4 },
	{ (void*)CpuExec0xe5 },
	{ (void*)CpuExec0xe6 },
	{ (void*)CpuExec0xe7 },
	{ (void*)CpuExec0xe8 },
	{ (void*)CpuExec0xe9 },
	{ (void*)CpuExec0xea },
	{ (void*)CpuExec0xeb },
	{ (void*)CpuExec0xec },
	{ (void*)CpuExec0xed },
	{ (void*)CpuExec0xee },
	{ (void*)CpuExec0xef },
	{ (void*)CpuExec0xf0 },
	{ (void*)CpuExec0xf1 },
	{ (void*)CpuExec0xf2 },
	{ (void*)CpuExec0xf3 },
	{ (void*)CpuExec0xf4 },
	{ (void*)CpuExec0xf5 },
	{ (void*)CpuExec0xf6 },
	{ (void*)CpuExec0xf7 },
	{ (void*)CpuExec0xf8 },
	{ (void*)CpuExec0xf9 },
	{ (void*)CpuExec0xfa },
	{ (void*)CpuExec0xfb },
	{ (void*)CpuExec0xfc },
	{ (void*)CpuExec0xfd },
	{ (void*)CpuExec0xfe },
	{ (void*)CpuExec0xff },
};
//---------------------------------------------------------------------------
extern ST_CPU Cpu;


//---------------------------------------------------------------------------
IWRAM_CODE void CpuExec(void)
{
	while(Cpu.SP.uw < Cpu.baseSP)
	{
/*
		if(Cpu.debugFlag == TRUE)
		{
			TRACEOUT("[%04X]: AF:%04X BC:%04X DE:%04X HL:%04X SP:%04X  m:%02X m1:%02X m2:%02X\n", 
				Cpu.PC.uw, Cpu.AF.uw, Cpu.BC.uw, Cpu.DE.uw, Cpu.HL.uw, Cpu.SP.uw,
				MemReadByte(Cpu.PC.uw), MemReadByte(Cpu.PC.uw+1), MemReadByte(Cpu.PC.uw+2));
		}
*/

		u8 pc = MemReadByte(Cpu.PC.uw);
		Cpu.PC.uw++;

		CpuExecTable[pc].pFunc();
	}
}
//---------------------------------------------------------------------------
// NOP
IWRAM_CODE void CpuExec0x00(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
// LD BC, [PC]
IWRAM_CODE void CpuExec0x01(void)
{
	Cpu.BC.uw = MemReadWord(Cpu.PC.uw);
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// LD [BC], A
IWRAM_CODE void CpuExec0x02(void)
{
	MemWriteByte(Cpu.BC.uw, Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// INC BC
IWRAM_CODE void CpuExec0x03(void)
{
	Cpu.BC.uw++;
}
//---------------------------------------------------------------------------
// INC B
IWRAM_CODE void CpuExec0x04(void)
{
	Cpu.BC.b.h = CpuExecInc(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// DEC B
IWRAM_CODE void CpuExec0x05(void)
{
	Cpu.BC.b.h = CpuExecDec(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// LD B, [PC]
IWRAM_CODE void CpuExec0x06(void)
{
	Cpu.BC.b.h = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RLCA
IWRAM_CODE void CpuExec0x07(void)
{
	Cpu.AF.b.h = CpuExecRlc(Cpu.AF.b.h, TRUE);
}
//---------------------------------------------------------------------------
// LD [PC], SP
IWRAM_CODE void CpuExec0x08(void)
{
	MemWriteWord(MemReadWord(Cpu.PC.uw), Cpu.SP.uw);
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// ADD HL, BC
IWRAM_CODE void CpuExec0x09(void)
{
	CpuExecAddWordHL(Cpu.BC.uw);
}
//---------------------------------------------------------------------------
// LD A, [BC]
IWRAM_CODE void CpuExec0x0a(void)
{
	Cpu.AF.b.h = MemReadByte(Cpu.BC.uw);
}
//---------------------------------------------------------------------------
// DEC BC
IWRAM_CODE void CpuExec0x0b(void)
{
	Cpu.BC.uw--;
}
//---------------------------------------------------------------------------
// INC C
IWRAM_CODE void CpuExec0x0c(void)
{
	Cpu.BC.b.l = CpuExecInc(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// DEC C
IWRAM_CODE void CpuExec0x0d(void)
{
	Cpu.BC.b.l = CpuExecDec(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// LD C, [PC]
IWRAM_CODE void CpuExec0x0e(void)
{
	Cpu.BC.b.l = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RRCA
IWRAM_CODE void CpuExec0x0f(void)
{
	Cpu.AF.b.h = CpuExecRrc(Cpu.AF.b.h, TRUE);
}
//---------------------------------------------------------------------------
// STOP
IWRAM_CODE void CpuExec0x10(void)
{
	// 
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// LD DE, [PC]
IWRAM_CODE void CpuExec0x11(void)
{
	Cpu.DE.uw = MemReadWord(Cpu.PC.uw);
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// LD [DE], A
IWRAM_CODE void CpuExec0x12(void)
{
	MemWriteByte(Cpu.DE.uw, Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// INC DE
IWRAM_CODE void CpuExec0x13(void)
{
	Cpu.DE.uw++;
}
//---------------------------------------------------------------------------
// INC D
IWRAM_CODE void CpuExec0x14(void)
{
	Cpu.DE.b.h = CpuExecInc(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// DEC D
IWRAM_CODE void CpuExec0x15(void)
{
	Cpu.DE.b.h = CpuExecDec(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// LD D, [PC]
IWRAM_CODE void CpuExec0x16(void)
{
	Cpu.DE.b.h = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RLA
IWRAM_CODE void CpuExec0x17(void)
{
	Cpu.AF.b.h = CpuExecRl(Cpu.AF.b.h, TRUE);
}
//---------------------------------------------------------------------------
// JR
IWRAM_CODE void CpuExec0x18(void)
{
	s8 offset = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	Cpu.PC.uw += offset;
}
//---------------------------------------------------------------------------
// ADD HL, DE
IWRAM_CODE void CpuExec0x19(void)
{
	CpuExecAddWordHL(Cpu.DE.uw);
}
//---------------------------------------------------------------------------
// LD A, [DE]
IWRAM_CODE void CpuExec0x1a(void)
{
	Cpu.AF.b.h = MemReadByte(Cpu.DE.uw);
}
//---------------------------------------------------------------------------
// DEC DE
IWRAM_CODE void CpuExec0x1b(void)
{
	Cpu.DE.uw--;
}
//---------------------------------------------------------------------------
// INC E
IWRAM_CODE void CpuExec0x1c(void)
{
	Cpu.DE.b.l = CpuExecInc(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// DEC E
IWRAM_CODE void CpuExec0x1d(void)
{
	Cpu.DE.b.l = CpuExecDec(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// LD E, [PC]
IWRAM_CODE void CpuExec0x1e(void)
{
	Cpu.DE.b.l = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RRA
IWRAM_CODE void CpuExec0x1f(void)
{
	Cpu.AF.b.h = CpuExecRr(Cpu.AF.b.h, TRUE);
}
//---------------------------------------------------------------------------
// JR NZ, [PC]
IWRAM_CODE void CpuExec0x20(void)
{
	s8 offset = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	if(!CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw += offset;
	}
}
//---------------------------------------------------------------------------
// LD HL, [PC]
IWRAM_CODE void CpuExec0x21(void)
{
	Cpu.HL.uw = MemReadWord(Cpu.PC.uw);
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// LD [HL+], A
IWRAM_CODE void CpuExec0x22(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.AF.b.h);
	Cpu.HL.uw++;
}
//---------------------------------------------------------------------------
// INC HL
IWRAM_CODE void CpuExec0x23(void)
{
	Cpu.HL.uw++;
}
//---------------------------------------------------------------------------
// INC H
IWRAM_CODE void CpuExec0x24(void)
{
	Cpu.HL.b.h = CpuExecInc(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// DEC H
IWRAM_CODE void CpuExec0x25(void)
{
	Cpu.HL.b.h = CpuExecDec(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// LD H, [PC]
IWRAM_CODE void CpuExec0x26(void)
{
	Cpu.HL.b.h = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// DAA
IWRAM_CODE void CpuExec0x27(void)
{
	s32 a = Cpu.AF.b.h;

	if(!CpuFlagIsSet(CPU_FLAG_SUB))
	{
		if(CpuFlagIsSet(CPU_FLAG_HALF) || ((a & 0xf) > 9))
		{
			a += 0x06;
		}

		if(CpuFlagIsSet(CPU_FLAG_CARRY) || (a > 0x9f))
		{
			a += 0x60;
		}
	}
	else
	{
		if(CpuFlagIsSet(CPU_FLAG_HALF))
		{
			a = (a - 6) & 0xff;
		}

		if(CpuFlagIsSet(CPU_FLAG_CARRY))
		{
			a -= 0x60;
		}
	}

	CpuFlagUnToggle(CPU_FLAG_HALF);
	CpuFlagUnToggle(CPU_FLAG_ZERO);

	if((a & 0x100) == 0x100)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	a &= 0xff;

	CpuFlagToggleZeroFromResult(a);
	Cpu.AF.b.h = a;
}
//---------------------------------------------------------------------------
// JR Z, [PC]
IWRAM_CODE void CpuExec0x28(void)
{
	s8 offset = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	if(CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw += offset;
	}
}
//---------------------------------------------------------------------------
// ADD HL, HL
IWRAM_CODE void CpuExec0x29(void)
{
	CpuExecAddWordHL(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD A, [HL+]
IWRAM_CODE void CpuExec0x2a(void)
{
	Cpu.AF.b.h = MemReadByte(Cpu.HL.uw);
	Cpu.HL.uw++;
}
//---------------------------------------------------------------------------
// DEC HL
IWRAM_CODE void CpuExec0x2b(void)
{
	Cpu.HL.uw--;
}
//---------------------------------------------------------------------------
// INC L
IWRAM_CODE void CpuExec0x2c(void)
{
	Cpu.HL.b.l = CpuExecInc(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// DEC L
IWRAM_CODE void CpuExec0x2d(void)
{
	Cpu.HL.b.l = CpuExecDec(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// LD L, [PC]
IWRAM_CODE void CpuExec0x2e(void)
{
	Cpu.HL.b.l = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// CPL
IWRAM_CODE void CpuExec0x2f(void)
{
	Cpu.AF.b.h = (~Cpu.AF.b.h);

	CpuFlagToggle(CPU_FLAG_SUB);
	CpuFlagToggle(CPU_FLAG_HALF);
}
//---------------------------------------------------------------------------
// JR NC, [PC]
IWRAM_CODE void CpuExec0x30(void)
{
	s8 offset = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	if(!CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw += offset;
	}
}
//---------------------------------------------------------------------------
// LD SP, [PC]
IWRAM_CODE void CpuExec0x31(void)
{
	Cpu.SP.uw = MemReadWord(Cpu.PC.uw);
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// LD [HL-], A
IWRAM_CODE void CpuExec0x32(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.AF.b.h);
	Cpu.HL.uw--;
}
//---------------------------------------------------------------------------
// INC SP
IWRAM_CODE void CpuExec0x33(void)
{
	Cpu.SP.uw++;
}
//---------------------------------------------------------------------------
// INC [HL]
IWRAM_CODE void CpuExec0x34(void)
{
	u8 result = CpuExecInc(MemReadByte(Cpu.HL.uw));
	MemWriteByte(Cpu.HL.uw, result);
}
//---------------------------------------------------------------------------
// DEC [HL]
IWRAM_CODE void CpuExec0x35(void)
{
	u8 result = CpuExecDec(MemReadByte(Cpu.HL.uw));
	MemWriteByte(Cpu.HL.uw, result);
}
//---------------------------------------------------------------------------
// LD [HL], [PC]
IWRAM_CODE void CpuExec0x36(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// SCF
IWRAM_CODE void CpuExec0x37(void)
{
	CpuFlagToggle(CPU_FLAG_CARRY);
	CpuFlagUnToggle(CPU_FLAG_SUB);
	CpuFlagUnToggle(CPU_FLAG_HALF);
}
//---------------------------------------------------------------------------
// JR C, [PC]
IWRAM_CODE void CpuExec0x38(void)
{
	s8 offset = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	if(CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw += offset;
	}
}
//---------------------------------------------------------------------------
// ADD HL, SP
IWRAM_CODE void CpuExec0x39(void)
{
	CpuExecAddWordHL(Cpu.SP.uw);
}
//---------------------------------------------------------------------------
// LD A, [HL-]
IWRAM_CODE void CpuExec0x3a(void)
{
	Cpu.AF.b.h = MemReadByte(Cpu.HL.uw);
	Cpu.HL.uw--;
}
//---------------------------------------------------------------------------
// DEC SP
IWRAM_CODE void CpuExec0x3b(void)
{
	Cpu.SP.uw--;
}
//---------------------------------------------------------------------------
// INC A
IWRAM_CODE void CpuExec0x3c(void)
{
	Cpu.AF.b.h = CpuExecInc(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// DEC A
IWRAM_CODE void CpuExec0x3d(void)
{
	Cpu.AF.b.h = CpuExecDec(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// LD A, [PC]
IWRAM_CODE void CpuExec0x3e(void)
{
	Cpu.AF.b.h = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// CCF
IWRAM_CODE void CpuExec0x3f(void)
{
	CpuFlagFlip(CPU_FLAG_CARRY);
	CpuFlagUnToggle(CPU_FLAG_SUB);
	CpuFlagUnToggle(CPU_FLAG_HALF);
}
//---------------------------------------------------------------------------
// LD B, B
IWRAM_CODE void CpuExec0x40(void)
{
	Cpu.BC.b.h = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD B, C
IWRAM_CODE void CpuExec0x41(void)
{
	Cpu.BC.b.h = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD B, D
IWRAM_CODE void CpuExec0x42(void)
{
	Cpu.BC.b.h = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD B, E
IWRAM_CODE void CpuExec0x43(void)
{
	Cpu.BC.b.h = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD B, H
IWRAM_CODE void CpuExec0x44(void)
{
	Cpu.BC.b.h = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD B, L
IWRAM_CODE void CpuExec0x45(void)
{
	Cpu.BC.b.h = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD B, [HL]
IWRAM_CODE void CpuExec0x46(void)
{
	Cpu.BC.b.h = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD B, A
IWRAM_CODE void CpuExec0x47(void)
{
	Cpu.BC.b.h = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// LD C, B
IWRAM_CODE void CpuExec0x48(void)
{
	Cpu.BC.b.l = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD C, C
IWRAM_CODE void CpuExec0x49(void)
{
	Cpu.BC.b.l = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD C, D
IWRAM_CODE void CpuExec0x4a(void)
{
	Cpu.BC.b.l = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD C, E
IWRAM_CODE void CpuExec0x4b(void)
{
	Cpu.BC.b.l = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD C, H
IWRAM_CODE void CpuExec0x4c(void)
{
	Cpu.BC.b.l = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD C, L
IWRAM_CODE void CpuExec0x4d(void)
{
	Cpu.BC.b.l = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD C, [HL]
IWRAM_CODE void CpuExec0x4e(void)
{
	Cpu.BC.b.l = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD C, A
IWRAM_CODE void CpuExec0x4f(void)
{
	Cpu.BC.b.l = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// LD D, B
IWRAM_CODE void CpuExec0x50(void)
{
	Cpu.DE.b.h = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD D, C
IWRAM_CODE void CpuExec0x51(void)
{
	Cpu.DE.b.h = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD D, D
IWRAM_CODE void CpuExec0x52(void)
{
	Cpu.DE.b.h = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD D, E
IWRAM_CODE void CpuExec0x53(void)
{
	Cpu.DE.b.h = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD D, H
IWRAM_CODE void CpuExec0x54(void)
{
	Cpu.DE.b.h = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD D, L
IWRAM_CODE void CpuExec0x55(void)
{
	Cpu.DE.b.h = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD D, [HL]
IWRAM_CODE void CpuExec0x56(void)
{
	Cpu.DE.b.h = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD D, A
IWRAM_CODE void CpuExec0x57(void)
{
	Cpu.DE.b.h = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// LD E, B
IWRAM_CODE void CpuExec0x58(void)
{
	Cpu.DE.b.l = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD E, C
IWRAM_CODE void CpuExec0x59(void)
{
	Cpu.DE.b.l = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD E, D
IWRAM_CODE void CpuExec0x5a(void)
{
	Cpu.DE.b.l = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD E, E
IWRAM_CODE void CpuExec0x5b(void)
{
	Cpu.DE.b.l = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD E, H
IWRAM_CODE void CpuExec0x5c(void)
{
	Cpu.DE.b.l = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD E, L
IWRAM_CODE void CpuExec0x5d(void)
{
	Cpu.DE.b.l = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD E, [HL]
IWRAM_CODE void CpuExec0x5e(void)
{
	Cpu.DE.b.l = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD E, A
IWRAM_CODE void CpuExec0x5f(void)
{
	Cpu.DE.b.l = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// LD H, B
IWRAM_CODE void CpuExec0x60(void)
{
	Cpu.HL.b.h = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD H, C
IWRAM_CODE void CpuExec0x61(void)
{
	Cpu.HL.b.h = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD H, D
IWRAM_CODE void CpuExec0x62(void)
{
	Cpu.HL.b.h = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD H, E
IWRAM_CODE void CpuExec0x63(void)
{
	Cpu.HL.b.h = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD H, H
IWRAM_CODE void CpuExec0x64(void)
{
	Cpu.HL.b.h = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD H, L
IWRAM_CODE void CpuExec0x65(void)
{
	Cpu.HL.b.h = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD H, [HL]
IWRAM_CODE void CpuExec0x66(void)
{
	Cpu.HL.b.h = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD H, A
IWRAM_CODE void CpuExec0x67(void)
{
	Cpu.HL.b.h = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// LD L, B
IWRAM_CODE void CpuExec0x68(void)
{
	Cpu.HL.b.l = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD L, C
IWRAM_CODE void CpuExec0x69(void)
{
	Cpu.HL.b.l = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD L, D
IWRAM_CODE void CpuExec0x6a(void)
{
	Cpu.HL.b.l = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD L, E
IWRAM_CODE void CpuExec0x6b(void)
{
	Cpu.HL.b.l = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD L, H
IWRAM_CODE void CpuExec0x6c(void)
{
	Cpu.HL.b.l = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD L, L
IWRAM_CODE void CpuExec0x6d(void)
{
	Cpu.HL.b.l = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD L, [HL]
IWRAM_CODE void CpuExec0x6e(void)
{
	Cpu.HL.b.l = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD L, A
IWRAM_CODE void CpuExec0x6f(void)
{
	Cpu.HL.b.l = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// LD [HL], B
IWRAM_CODE void CpuExec0x70(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// LD [HL], C
IWRAM_CODE void CpuExec0x71(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// LD [HL], D
IWRAM_CODE void CpuExec0x72(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// LD [HL], E
IWRAM_CODE void CpuExec0x73(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// LD [HL], H
IWRAM_CODE void CpuExec0x74(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// LD [HL], L
IWRAM_CODE void CpuExec0x75(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// HALT
IWRAM_CODE void CpuExec0x76(void)
{
	// 
	// EMPTY
}
//---------------------------------------------------------------------------
// LD [HL], A
IWRAM_CODE void CpuExec0x77(void)
{
	MemWriteByte(Cpu.HL.uw, Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// LD A, B
IWRAM_CODE void CpuExec0x78(void)
{
	Cpu.AF.b.h = Cpu.BC.b.h;
}
//---------------------------------------------------------------------------
// LD A, C
IWRAM_CODE void CpuExec0x79(void)
{
	Cpu.AF.b.h = Cpu.BC.b.l;
}
//---------------------------------------------------------------------------
// LD A, D
IWRAM_CODE void CpuExec0x7a(void)
{
	Cpu.AF.b.h = Cpu.DE.b.h;
}
//---------------------------------------------------------------------------
// LD A, E
IWRAM_CODE void CpuExec0x7b(void)
{
	Cpu.AF.b.h = Cpu.DE.b.l;
}
//---------------------------------------------------------------------------
// LD A, H
IWRAM_CODE void CpuExec0x7c(void)
{
	Cpu.AF.b.h = Cpu.HL.b.h;
}
//---------------------------------------------------------------------------
// LD A, L
IWRAM_CODE void CpuExec0x7d(void)
{
	Cpu.AF.b.h = Cpu.HL.b.l;
}
//---------------------------------------------------------------------------
// LD A, [HL]
IWRAM_CODE void CpuExec0x7e(void)
{
	Cpu.AF.b.h = MemReadByte(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// LD A, A
IWRAM_CODE void CpuExec0x7f(void)
{
	Cpu.AF.b.h = Cpu.AF.b.h;
}
//---------------------------------------------------------------------------
// ADD A, B
IWRAM_CODE void CpuExec0x80(void)
{
	CpuExecAddByte(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// ADD A, C
IWRAM_CODE void CpuExec0x81(void)
{
	CpuExecAddByte(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// ADD A, D
IWRAM_CODE void CpuExec0x82(void)
{
	CpuExecAddByte(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// ADD A, E
IWRAM_CODE void CpuExec0x83(void)
{
	CpuExecAddByte(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// ADD A, H
IWRAM_CODE void CpuExec0x84(void)
{
	CpuExecAddByte(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// ADD A, L
IWRAM_CODE void CpuExec0x85(void)
{
	CpuExecAddByte(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// ADD A, [HL]
IWRAM_CODE void CpuExec0x86(void)
{
	CpuExecAddByte(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// ADD A, A
IWRAM_CODE void CpuExec0x87(void)
{
	CpuExecAddByte(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// ADC A, B
IWRAM_CODE void CpuExec0x88(void)
{
	CpuExecAdc(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// ADC A, C
IWRAM_CODE void CpuExec0x89(void)
{
	CpuExecAdc(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// ADC A, D
IWRAM_CODE void CpuExec0x8a(void)
{
	CpuExecAdc(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// ADC A, E
IWRAM_CODE void CpuExec0x8b(void)
{
	CpuExecAdc(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// ADC A, H
IWRAM_CODE void CpuExec0x8c(void)
{
	CpuExecAdc(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// ADC A, L
IWRAM_CODE void CpuExec0x8d(void)
{
	CpuExecAdc(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// ADC A, [HL]
IWRAM_CODE void CpuExec0x8e(void)
{
	CpuExecAdc(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// ADC A, A
IWRAM_CODE void CpuExec0x8f(void)
{
	CpuExecAdc(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// SUB A, B
IWRAM_CODE void CpuExec0x90(void)
{
	CpuExecSub(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// SUB A, C
IWRAM_CODE void CpuExec0x91(void)
{
	CpuExecSub(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// SUB A, D
IWRAM_CODE void CpuExec0x92(void)
{
	CpuExecSub(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// SUB A, E
IWRAM_CODE void CpuExec0x93(void)
{
	CpuExecSub(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// SUB A, H
IWRAM_CODE void CpuExec0x94(void)
{
	CpuExecSub(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// SUB A, L
IWRAM_CODE void CpuExec0x95(void)
{
	CpuExecSub(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// SUB A, [HL]
IWRAM_CODE void CpuExec0x96(void)
{
	CpuExecSub(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// SUB A, A
IWRAM_CODE void CpuExec0x97(void)
{
	CpuExecSub(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// SBC A, B
IWRAM_CODE void CpuExec0x98(void)
{
	CpuExecSbc(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// SBC A, C
IWRAM_CODE void CpuExec0x99(void)
{
	CpuExecSbc(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// SBC A, D
IWRAM_CODE void CpuExec0x9a(void)
{
	CpuExecSbc(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// SBC A, E
IWRAM_CODE void CpuExec0x9b(void)
{
	CpuExecSbc(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// SBC A, H
IWRAM_CODE void CpuExec0x9c(void)
{
	CpuExecSbc(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// SBC A, L
IWRAM_CODE void CpuExec0x9d(void)
{
	CpuExecSbc(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// SBC A, [HL]
IWRAM_CODE void CpuExec0x9e(void)
{
	CpuExecSbc(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// SBC A, A
IWRAM_CODE void CpuExec0x9f(void)
{
	CpuExecSbc(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// AND B
IWRAM_CODE void CpuExec0xa0(void)
{
	CpuExecAnd(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// AND C
IWRAM_CODE void CpuExec0xa1(void)
{
	CpuExecAnd(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// AND D
IWRAM_CODE void CpuExec0xa2(void)
{
	CpuExecAnd(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// AND E
IWRAM_CODE void CpuExec0xa3(void)
{
	CpuExecAnd(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// AND H
IWRAM_CODE void CpuExec0xa4(void)
{
	CpuExecAnd(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// AND L
IWRAM_CODE void CpuExec0xa5(void)
{
	CpuExecAnd(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// AND [HL]
IWRAM_CODE void CpuExec0xa6(void)
{
	CpuExecAnd(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// AND A
IWRAM_CODE void CpuExec0xa7(void)
{
	CpuExecAnd(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// XOR B
IWRAM_CODE void CpuExec0xa8(void)
{
	CpuExecXor(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// XOR C
IWRAM_CODE void CpuExec0xa9(void)
{
	CpuExecXor(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// XOR D
IWRAM_CODE void CpuExec0xaa(void)
{
	CpuExecXor(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// XOR E
IWRAM_CODE void CpuExec0xab(void)
{
	CpuExecXor(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// XOR H
IWRAM_CODE void CpuExec0xac(void)
{
	CpuExecXor(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// XOR L
IWRAM_CODE void CpuExec0xad(void)
{
	CpuExecXor(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// XOR [HL]
IWRAM_CODE void CpuExec0xae(void)
{
	CpuExecXor(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// XOR A
IWRAM_CODE void CpuExec0xaf(void)
{
	CpuExecXor(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// OR B
IWRAM_CODE void CpuExec0xb0(void)
{
	CpuExecOr(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// OR C
IWRAM_CODE void CpuExec0xb1(void)
{
	CpuExecOr(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// OR D
IWRAM_CODE void CpuExec0xb2(void)
{
	CpuExecOr(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// OR E
IWRAM_CODE void CpuExec0xb3(void)
{
	CpuExecOr(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// OR H
IWRAM_CODE void CpuExec0xb4(void)
{
	CpuExecOr(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// OR L
IWRAM_CODE void CpuExec0xb5(void)
{
	CpuExecOr(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// OR [HL]
IWRAM_CODE void CpuExec0xb6(void)
{
	CpuExecOr(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// OR A
IWRAM_CODE void CpuExec0xb7(void)
{
	CpuExecOr(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// CP B
IWRAM_CODE void CpuExec0xb8(void)
{
	CpuExecCp(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// CP C
IWRAM_CODE void CpuExec0xb9(void)
{
	CpuExecCp(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// CP D
IWRAM_CODE void CpuExec0xba(void)
{
	CpuExecCp(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// CP E
IWRAM_CODE void CpuExec0xbb(void)
{
	CpuExecCp(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// CP H
IWRAM_CODE void CpuExec0xbc(void)
{
	CpuExecCp(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// CP L
IWRAM_CODE void CpuExec0xbd(void)
{
	CpuExecCp(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// CP [HL]
IWRAM_CODE void CpuExec0xbe(void)
{
	CpuExecCp(MemReadByte(Cpu.HL.uw));
}
//---------------------------------------------------------------------------
// CP A
IWRAM_CODE void CpuExec0xbf(void)
{
	CpuExecCp(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// RET NZ
IWRAM_CODE void CpuExec0xc0(void)
{
	if(!CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw = CpuPopStack();
	}
}
//---------------------------------------------------------------------------
// POP BC
IWRAM_CODE void CpuExec0xc1(void)
{
	Cpu.BC.uw = CpuPopStack();
}
//---------------------------------------------------------------------------
// JP NZ, [PC]
IWRAM_CODE void CpuExec0xc2(void)
{
	if(CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw += 2;
	}
	else
	{
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
}
//---------------------------------------------------------------------------
// JP [PC]
IWRAM_CODE void CpuExec0xc3(void)
{
	Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
}
//---------------------------------------------------------------------------
// CALL NZ, [PC]
IWRAM_CODE void CpuExec0xc4(void)
{
	if(CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw += 2;
	}
	else
	{
		CpuPushStack(Cpu.PC.uw + 2);
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
}
//---------------------------------------------------------------------------
// PUSH BC
IWRAM_CODE void CpuExec0xc5(void)
{
	CpuPushStack(Cpu.BC.uw);
}
//---------------------------------------------------------------------------
// ADD A, [PC]
IWRAM_CODE void CpuExec0xc6(void)
{
	CpuExecAddByte(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $00
IWRAM_CODE void CpuExec0xc7(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x00;
*/

	CpuExecRstPatch(0x00);
}
//---------------------------------------------------------------------------
// RET Z
IWRAM_CODE void CpuExec0xc8(void)
{
	if(CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw = CpuPopStack();
	}
}
//---------------------------------------------------------------------------
// RET
IWRAM_CODE void CpuExec0xc9(void)
{
	Cpu.PC.uw = CpuPopStack();
}
//---------------------------------------------------------------------------
// JP Z, [PC]
IWRAM_CODE void CpuExec0xca(void)
{
	if(CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
	else
	{
		Cpu.PC.uw += 2;
	}
}
//---------------------------------------------------------------------------
// CB ..
IWRAM_CODE void CpuExec0xcb(void)
{
	CpuExecCb();
}
//---------------------------------------------------------------------------
// CALL Z, [PC]
IWRAM_CODE void CpuExec0xcc(void)
{
	if(CpuFlagIsSet(CPU_FLAG_ZERO))
	{
		CpuPushStack(Cpu.PC.uw + 2);
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
	else
	{
		Cpu.PC.uw += 2;
	}
}
//---------------------------------------------------------------------------
// CALL [PC]
IWRAM_CODE void CpuExec0xcd(void)
{
	CpuPushStack(Cpu.PC.uw + 2);
	Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
}
//---------------------------------------------------------------------------
// ADC A, [PC]
IWRAM_CODE void CpuExec0xce(void)
{
	CpuExecAdc(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $08
IWRAM_CODE void CpuExec0xcf(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x08;
*/

	CpuExecRstPatch(0x08);
}
//---------------------------------------------------------------------------
// RET NC
IWRAM_CODE void CpuExec0xd0(void)
{
	if(!CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw = CpuPopStack();
	}
}
//---------------------------------------------------------------------------
// POP DE
IWRAM_CODE void CpuExec0xd1(void)
{
	Cpu.DE.uw = CpuPopStack();
}
//---------------------------------------------------------------------------
// JP NC, [PC]
IWRAM_CODE void CpuExec0xd2(void)
{
	if(CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw += 2;
	}
	else
	{
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xd3(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// CALL NC, [PC]
IWRAM_CODE void CpuExec0xd4(void)
{
	if(CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw += 2;
	}
	else
	{
		CpuPushStack(Cpu.PC.uw + 2);
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
}
//---------------------------------------------------------------------------
// PUSH DE
IWRAM_CODE void CpuExec0xd5(void)
{
	CpuPushStack(Cpu.DE.uw);
}
//---------------------------------------------------------------------------
// SUB [PC]
IWRAM_CODE void CpuExec0xd6(void)
{
	CpuExecSub(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $10
IWRAM_CODE void CpuExec0xd7(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x10;
*/

	CpuExecRstPatch(0x10);
}
//---------------------------------------------------------------------------
// RET C
IWRAM_CODE void CpuExec0xd8(void)
{
	if(CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw = CpuPopStack();
	}
}
//---------------------------------------------------------------------------
// RETI
IWRAM_CODE void CpuExec0xd9(void)
{
	Cpu.PC.uw = CpuPopStack();
}
//---------------------------------------------------------------------------
// JP C, [PC]
IWRAM_CODE void CpuExec0xda(void)
{
	if(CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
	else
	{
		Cpu.PC.uw += 2;
	}
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xdb(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// CALL C, [PC]
IWRAM_CODE void CpuExec0xdc(void)
{
	if(CpuFlagIsSet(CPU_FLAG_CARRY))
	{
		CpuPushStack(Cpu.PC.uw + 2);
		Cpu.PC.uw = MemReadWord(Cpu.PC.uw);
	}
	else
	{
		Cpu.PC.uw += 2;
	}
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xdd(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// SBC A, [PC]
IWRAM_CODE void CpuExec0xde(void)
{
	CpuExecSbc(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $18
IWRAM_CODE void CpuExec0xdf(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x18;
*/

	CpuExecRstPatch(0x18);
}
//---------------------------------------------------------------------------
// LD [$FF00 + [PC]], A
IWRAM_CODE void CpuExec0xe0(void)
{
	MemWriteByte(0xff00 + MemReadByte(Cpu.PC.uw), Cpu.AF.b.h);
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// POP HL
IWRAM_CODE void CpuExec0xe1(void)
{
	Cpu.HL.uw = CpuPopStack();
}
//---------------------------------------------------------------------------
// LD [$FF00 + C], A
IWRAM_CODE void CpuExec0xe2(void)
{
	MemWriteByte(0xff00 + Cpu.BC.b.l, Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xe3(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xe4(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// PUSH HL
IWRAM_CODE void CpuExec0xe5(void)
{
	CpuPushStack(Cpu.HL.uw);
}
//---------------------------------------------------------------------------
// AND [PC]
IWRAM_CODE void CpuExec0xe6(void)
{
	CpuExecAnd(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $20
IWRAM_CODE void CpuExec0xe7(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x20;
*/

	CpuExecRstPatch(0x20);
}
//---------------------------------------------------------------------------
// ADD SP, [PC]
IWRAM_CODE void CpuExec0xe8(void)
{
	CpuExecAddWordSP(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// JP HL
IWRAM_CODE void CpuExec0xe9(void)
{
	Cpu.PC.uw = Cpu.HL.uw;
}
//---------------------------------------------------------------------------
// LD [PC], A
IWRAM_CODE void CpuExec0xea(void)
{
	MemWriteByte(MemReadWord(Cpu.PC.uw), Cpu.AF.b.h);
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xeb(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xec(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xed(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// XOR [PC]
IWRAM_CODE void CpuExec0xee(void)
{
	CpuExecXor(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $28
IWRAM_CODE void CpuExec0xef(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x28;
*/

	CpuExecRstPatch(0x28);
}
//---------------------------------------------------------------------------
// LD A, [$FF00 + [PC]]
IWRAM_CODE void CpuExec0xf0(void)
{
	Cpu.AF.b.h = MemReadByte(0xff00 + MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// POP AF
IWRAM_CODE void CpuExec0xf1(void)
{
	Cpu.AF.uw = CpuPopStack();
}
//---------------------------------------------------------------------------
// LD A, [$FF00 + C]
IWRAM_CODE void CpuExec0xf2(void)
{
	Cpu.AF.b.h = MemReadByte(0xff00 + Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// DI
IWRAM_CODE void CpuExec0xf3(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xf4(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// PUSH AF
IWRAM_CODE void CpuExec0xf5(void)
{
	CpuPushStack(Cpu.AF.uw);
}
//---------------------------------------------------------------------------
// OR [PC]
IWRAM_CODE void CpuExec0xf6(void)
{
	CpuExecOr(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $30
IWRAM_CODE void CpuExec0xf7(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x30;
*/

	CpuExecRstPatch(0x30);
}
//---------------------------------------------------------------------------
// LD HL, SP+[PC]
IWRAM_CODE void CpuExec0xf8(void)
{
	u8 n = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	u16 result = Cpu.SP.uw + n;
	CpuFlagClearAll();

	if(((Cpu.SP.uw ^ n ^ result) & 0x100) == 0x100)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if(((Cpu.SP.uw ^ n ^ result) & 0x10) == 0x10)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	Cpu.HL.uw = result;
}
//---------------------------------------------------------------------------
// LD SP, HL
IWRAM_CODE void CpuExec0xf9(void)
{
	Cpu.SP.uw = Cpu.HL.uw;
}
//---------------------------------------------------------------------------
// LD A, [[PC]]
IWRAM_CODE void CpuExec0xfa(void)
{
	Cpu.AF.b.h = MemReadByte(MemReadWord(Cpu.PC.uw));
	Cpu.PC.uw += 2;
}
//---------------------------------------------------------------------------
// EI
IWRAM_CODE void CpuExec0xfb(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xfc(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// UNKNOWN
IWRAM_CODE void CpuExec0xfd(void)
{
	CpuError();
}
//---------------------------------------------------------------------------
// CP [PC]
IWRAM_CODE void CpuExec0xfe(void)
{
	CpuExecCp(MemReadByte(Cpu.PC.uw));
	Cpu.PC.uw++;
}
//---------------------------------------------------------------------------
// RST $38
IWRAM_CODE void CpuExec0xff(void)
{
/*
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = 0x38;
*/

	CpuExecRstPatch(0x38);
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecInc(u8 r)
{
	u8 result = r + 1;

    CpuFlagIsSet(CPU_FLAG_CARRY) ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();
	CpuFlagToggleZeroFromResult(result);

	if((result & 0x0f) == 0x00)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecDec(u8 r)
{
	u8 result = r - 1;

    CpuFlagIsSet(CPU_FLAG_CARRY) ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();
	CpuFlagToggle(CPU_FLAG_SUB);
	CpuFlagToggleZeroFromResult(result);

	if((result & 0x0f) == 0x0f)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecAddWordHL(u16 r2)
{
	s32 result = Cpu.HL.uw + r2;

	CpuFlagIsSet(CPU_FLAG_ZERO) ? CpuFlagSet(CPU_FLAG_ZERO) : CpuFlagClearAll();

	if(result & 0x10000)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if((Cpu.HL.uw ^ r2 ^ (result & 0xffff)) & 0x1000)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	Cpu.HL.uw = (u16)result;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecAddWordSP(u8 r2)
{
	s32 result = Cpu.SP.uw + (s8)r2;

	CpuFlagClearAll();

	if(((Cpu.SP.uw ^ r2 ^ (result & 0xffff)) & 0x100) == 0x100)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if(((Cpu.SP.uw ^ r2 ^ (result & 0xffff)) & 0x10) == 0x10)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	Cpu.SP.uw = (u16)result;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecAddByte(u8 r2)
{
	s32 result = Cpu.AF.b.h + r2;
	s32 carrybits = Cpu.AF.b.h ^ r2 ^ result;

	Cpu.AF.b.h = (u8)result;

	CpuFlagClearAll();
	CpuFlagToggleZeroFromResult((u8)result);

	if((carrybits & 0x100) != 0)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if((carrybits & 0x10) != 0)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecAdc(u8 r2)
{
	s32 carry = CpuFlagIsSet(CPU_FLAG_CARRY) ? 1 : 0;
	s32 result = Cpu.AF.b.h + r2 + carry;

	CpuFlagClearAll();
	CpuFlagToggleZeroFromResult((u8)result);

	if(result > 0xff)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if(((Cpu.AF.b.h & 0x0F) + (r2 & 0x0F) + carry) > 0x0f)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	Cpu.AF.b.h = (u8)result;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecSub(u8 r2)
{
	s32 result = Cpu.AF.b.h - r2;
	s32 carrybits = Cpu.AF.b.h ^ r2 ^ result;

	Cpu.AF.b.h = (u8)result;

	CpuFlagSet(CPU_FLAG_SUB);
	CpuFlagToggleZeroFromResult((u8)result);

	if((carrybits & 0x100) != 0)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if((carrybits & 0x10) != 0)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecSbc(u8 r2)
{
	s32 carry = CpuFlagIsSet(CPU_FLAG_CARRY) ? 1 : 0;
	s32 result = Cpu.AF.b.h - r2 - carry;

	CpuFlagSet(CPU_FLAG_SUB);
	CpuFlagToggleZeroFromResult((u8)result);

	if(result < 0)
	{
		CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if(((Cpu.AF.b.h & 0x0F) - (r2 & 0x0F) - carry) < 0)
	{
		CpuFlagToggle(CPU_FLAG_HALF);
	}

	Cpu.AF.b.h = (u8)result;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecAnd(u8 r2)
{
	u8 result = Cpu.AF.b.h & r2;
	Cpu.AF.b.h = result;

	CpuFlagSet(CPU_FLAG_HALF);
	CpuFlagToggleZeroFromResult(result);
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecXor(u8 r2)
{
	u8 result = Cpu.AF.b.h ^ r2;
	Cpu.AF.b.h = result;

	CpuFlagClearAll();
	CpuFlagToggleZeroFromResult(result);
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecOr(u8 r2)
{
	u8 result = Cpu.AF.b.h | r2;
	Cpu.AF.b.h = result;

	CpuFlagClearAll();
	CpuFlagToggleZeroFromResult(result);
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecCp(u8 r2)
{
	CpuFlagSet(CPU_FLAG_SUB);

	if(Cpu.AF.b.h < r2)
	{
	    CpuFlagToggle(CPU_FLAG_CARRY);
	}

	if(Cpu.AF.b.h == r2)
	{
	    CpuFlagToggle(CPU_FLAG_ZERO);
	}

	if(((Cpu.AF.b.h - r2) & 0xF) > (Cpu.AF.b.h & 0xF))
	{
	    CpuFlagToggle(CPU_FLAG_HALF);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecRstPatch(u8 adr)
{
	CpuPushStack(Cpu.PC.uw);
	Cpu.PC.uw = Cpu.baseRst + adr;

//	TRACEOUT("RST 0x%x, CALL:%x\n", adr, Cpu.PC.uw);
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuFlagIsSet(u8 flag)
{
	return (Cpu.AF.b.l & flag) != 0;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuFlagSet(u8 flag)
{
	Cpu.AF.b.l = flag;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuFlagClearAll(void)
{
	Cpu.AF.b.l = CPU_FLAG_NONE;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuFlagToggle(u8 flag)
{
	Cpu.AF.b.l |= flag;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuFlagUnToggle(u8 flag)
{
	Cpu.AF.b.l &= (~flag);
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuFlagFlip(u8 flag)
{
	Cpu.AF.b.l ^= flag;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuFlagToggleZeroFromResult(u8 result)
{
	if(result == 0)
	{
		CpuFlagToggle(CPU_FLAG_ZERO);
	}
}
