#include "cpu.h"
#include "cpu2.h"
#include "cpu3.h"
#include "mem.h"

// Gameboy CPU Prefix CB

//---------------------------------------------------------------------------
ST_CPU_EXEC_TABLE CpuExecCbTable[0x100] = {
	{ (void*)CpuExecCb0x00 },
	{ (void*)CpuExecCb0x01 },
	{ (void*)CpuExecCb0x02 },
	{ (void*)CpuExecCb0x03 },
	{ (void*)CpuExecCb0x04 },
	{ (void*)CpuExecCb0x05 },
	{ (void*)CpuExecCb0x06 },
	{ (void*)CpuExecCb0x07 },
	{ (void*)CpuExecCb0x08 },
	{ (void*)CpuExecCb0x09 },
	{ (void*)CpuExecCb0x0a },
	{ (void*)CpuExecCb0x0b },
	{ (void*)CpuExecCb0x0c },
	{ (void*)CpuExecCb0x0d },
	{ (void*)CpuExecCb0x0e },
	{ (void*)CpuExecCb0x0f },
	{ (void*)CpuExecCb0x10 },
	{ (void*)CpuExecCb0x11 },
	{ (void*)CpuExecCb0x12 },
	{ (void*)CpuExecCb0x13 },
	{ (void*)CpuExecCb0x14 },
	{ (void*)CpuExecCb0x15 },
	{ (void*)CpuExecCb0x16 },
	{ (void*)CpuExecCb0x17 },
	{ (void*)CpuExecCb0x18 },
	{ (void*)CpuExecCb0x19 },
	{ (void*)CpuExecCb0x1a },
	{ (void*)CpuExecCb0x1b },
	{ (void*)CpuExecCb0x1c },
	{ (void*)CpuExecCb0x1d },
	{ (void*)CpuExecCb0x1e },
	{ (void*)CpuExecCb0x1f },
	{ (void*)CpuExecCb0x20 },
	{ (void*)CpuExecCb0x21 },
	{ (void*)CpuExecCb0x22 },
	{ (void*)CpuExecCb0x23 },
	{ (void*)CpuExecCb0x24 },
	{ (void*)CpuExecCb0x25 },
	{ (void*)CpuExecCb0x26 },
	{ (void*)CpuExecCb0x27 },
	{ (void*)CpuExecCb0x28 },
	{ (void*)CpuExecCb0x29 },
	{ (void*)CpuExecCb0x2a },
	{ (void*)CpuExecCb0x2b },
	{ (void*)CpuExecCb0x2c },
	{ (void*)CpuExecCb0x2d },
	{ (void*)CpuExecCb0x2e },
	{ (void*)CpuExecCb0x2f },
	{ (void*)CpuExecCb0x30 },
	{ (void*)CpuExecCb0x31 },
	{ (void*)CpuExecCb0x32 },
	{ (void*)CpuExecCb0x33 },
	{ (void*)CpuExecCb0x34 },
	{ (void*)CpuExecCb0x35 },
	{ (void*)CpuExecCb0x36 },
	{ (void*)CpuExecCb0x37 },
	{ (void*)CpuExecCb0x38 },
	{ (void*)CpuExecCb0x39 },
	{ (void*)CpuExecCb0x3a },
	{ (void*)CpuExecCb0x3b },
	{ (void*)CpuExecCb0x3c },
	{ (void*)CpuExecCb0x3d },
	{ (void*)CpuExecCb0x3e },
	{ (void*)CpuExecCb0x3f },
	{ (void*)CpuExecCb0x40 },
	{ (void*)CpuExecCb0x41 },
	{ (void*)CpuExecCb0x42 },
	{ (void*)CpuExecCb0x43 },
	{ (void*)CpuExecCb0x44 },
	{ (void*)CpuExecCb0x45 },
	{ (void*)CpuExecCb0x46 },
	{ (void*)CpuExecCb0x47 },
	{ (void*)CpuExecCb0x48 },
	{ (void*)CpuExecCb0x49 },
	{ (void*)CpuExecCb0x4a },
	{ (void*)CpuExecCb0x4b },
	{ (void*)CpuExecCb0x4c },
	{ (void*)CpuExecCb0x4d },
	{ (void*)CpuExecCb0x4e },
	{ (void*)CpuExecCb0x4f },
	{ (void*)CpuExecCb0x50 },
	{ (void*)CpuExecCb0x51 },
	{ (void*)CpuExecCb0x52 },
	{ (void*)CpuExecCb0x53 },
	{ (void*)CpuExecCb0x54 },
	{ (void*)CpuExecCb0x55 },
	{ (void*)CpuExecCb0x56 },
	{ (void*)CpuExecCb0x57 },
	{ (void*)CpuExecCb0x58 },
	{ (void*)CpuExecCb0x59 },
	{ (void*)CpuExecCb0x5a },
	{ (void*)CpuExecCb0x5b },
	{ (void*)CpuExecCb0x5c },
	{ (void*)CpuExecCb0x5d },
	{ (void*)CpuExecCb0x5e },
	{ (void*)CpuExecCb0x5f },
	{ (void*)CpuExecCb0x60 },
	{ (void*)CpuExecCb0x61 },
	{ (void*)CpuExecCb0x62 },
	{ (void*)CpuExecCb0x63 },
	{ (void*)CpuExecCb0x64 },
	{ (void*)CpuExecCb0x65 },
	{ (void*)CpuExecCb0x66 },
	{ (void*)CpuExecCb0x67 },
	{ (void*)CpuExecCb0x68 },
	{ (void*)CpuExecCb0x69 },
	{ (void*)CpuExecCb0x6a },
	{ (void*)CpuExecCb0x6b },
	{ (void*)CpuExecCb0x6c },
	{ (void*)CpuExecCb0x6d },
	{ (void*)CpuExecCb0x6e },
	{ (void*)CpuExecCb0x6f },
	{ (void*)CpuExecCb0x70 },
	{ (void*)CpuExecCb0x71 },
	{ (void*)CpuExecCb0x72 },
	{ (void*)CpuExecCb0x73 },
	{ (void*)CpuExecCb0x74 },
	{ (void*)CpuExecCb0x75 },
	{ (void*)CpuExecCb0x76 },
	{ (void*)CpuExecCb0x77 },
	{ (void*)CpuExecCb0x78 },
	{ (void*)CpuExecCb0x79 },
	{ (void*)CpuExecCb0x7a },
	{ (void*)CpuExecCb0x7b },
	{ (void*)CpuExecCb0x7c },
	{ (void*)CpuExecCb0x7d },
	{ (void*)CpuExecCb0x7e },
	{ (void*)CpuExecCb0x7f },
	{ (void*)CpuExecCb0x80 },
	{ (void*)CpuExecCb0x81 },
	{ (void*)CpuExecCb0x82 },
	{ (void*)CpuExecCb0x83 },
	{ (void*)CpuExecCb0x84 },
	{ (void*)CpuExecCb0x85 },
	{ (void*)CpuExecCb0x86 },
	{ (void*)CpuExecCb0x87 },
	{ (void*)CpuExecCb0x88 },
	{ (void*)CpuExecCb0x89 },
	{ (void*)CpuExecCb0x8a },
	{ (void*)CpuExecCb0x8b },
	{ (void*)CpuExecCb0x8c },
	{ (void*)CpuExecCb0x8d },
	{ (void*)CpuExecCb0x8e },
	{ (void*)CpuExecCb0x8f },
	{ (void*)CpuExecCb0x90 },
	{ (void*)CpuExecCb0x91 },
	{ (void*)CpuExecCb0x92 },
	{ (void*)CpuExecCb0x93 },
	{ (void*)CpuExecCb0x94 },
	{ (void*)CpuExecCb0x95 },
	{ (void*)CpuExecCb0x96 },
	{ (void*)CpuExecCb0x97 },
	{ (void*)CpuExecCb0x98 },
	{ (void*)CpuExecCb0x99 },
	{ (void*)CpuExecCb0x9a },
	{ (void*)CpuExecCb0x9b },
	{ (void*)CpuExecCb0x9c },
	{ (void*)CpuExecCb0x9d },
	{ (void*)CpuExecCb0x9e },
	{ (void*)CpuExecCb0x9f },
	{ (void*)CpuExecCb0xa0 },
	{ (void*)CpuExecCb0xa1 },
	{ (void*)CpuExecCb0xa2 },
	{ (void*)CpuExecCb0xa3 },
	{ (void*)CpuExecCb0xa4 },
	{ (void*)CpuExecCb0xa5 },
	{ (void*)CpuExecCb0xa6 },
	{ (void*)CpuExecCb0xa7 },
	{ (void*)CpuExecCb0xa8 },
	{ (void*)CpuExecCb0xa9 },
	{ (void*)CpuExecCb0xaa },
	{ (void*)CpuExecCb0xab },
	{ (void*)CpuExecCb0xac },
	{ (void*)CpuExecCb0xad },
	{ (void*)CpuExecCb0xae },
	{ (void*)CpuExecCb0xaf },
	{ (void*)CpuExecCb0xb0 },
	{ (void*)CpuExecCb0xb1 },
	{ (void*)CpuExecCb0xb2 },
	{ (void*)CpuExecCb0xb3 },
	{ (void*)CpuExecCb0xb4 },
	{ (void*)CpuExecCb0xb5 },
	{ (void*)CpuExecCb0xb6 },
	{ (void*)CpuExecCb0xb7 },
	{ (void*)CpuExecCb0xb8 },
	{ (void*)CpuExecCb0xb9 },
	{ (void*)CpuExecCb0xba },
	{ (void*)CpuExecCb0xbb },
	{ (void*)CpuExecCb0xbc },
	{ (void*)CpuExecCb0xbd },
	{ (void*)CpuExecCb0xbe },
	{ (void*)CpuExecCb0xbf },
	{ (void*)CpuExecCb0xc0 },
	{ (void*)CpuExecCb0xc1 },
	{ (void*)CpuExecCb0xc2 },
	{ (void*)CpuExecCb0xc3 },
	{ (void*)CpuExecCb0xc4 },
	{ (void*)CpuExecCb0xc5 },
	{ (void*)CpuExecCb0xc6 },
	{ (void*)CpuExecCb0xc7 },
	{ (void*)CpuExecCb0xc8 },
	{ (void*)CpuExecCb0xc9 },
	{ (void*)CpuExecCb0xca },
	{ (void*)CpuExecCb0xcb },
	{ (void*)CpuExecCb0xcc },
	{ (void*)CpuExecCb0xcd },
	{ (void*)CpuExecCb0xce },
	{ (void*)CpuExecCb0xcf },
	{ (void*)CpuExecCb0xd0 },
	{ (void*)CpuExecCb0xd1 },
	{ (void*)CpuExecCb0xd2 },
	{ (void*)CpuExecCb0xd3 },
	{ (void*)CpuExecCb0xd4 },
	{ (void*)CpuExecCb0xd5 },
	{ (void*)CpuExecCb0xd6 },
	{ (void*)CpuExecCb0xd7 },
	{ (void*)CpuExecCb0xd8 },
	{ (void*)CpuExecCb0xd9 },
	{ (void*)CpuExecCb0xda },
	{ (void*)CpuExecCb0xdb },
	{ (void*)CpuExecCb0xdc },
	{ (void*)CpuExecCb0xdd },
	{ (void*)CpuExecCb0xde },
	{ (void*)CpuExecCb0xdf },
	{ (void*)CpuExecCb0xe0 },
	{ (void*)CpuExecCb0xe1 },
	{ (void*)CpuExecCb0xe2 },
	{ (void*)CpuExecCb0xe3 },
	{ (void*)CpuExecCb0xe4 },
	{ (void*)CpuExecCb0xe5 },
	{ (void*)CpuExecCb0xe6 },
	{ (void*)CpuExecCb0xe7 },
	{ (void*)CpuExecCb0xe8 },
	{ (void*)CpuExecCb0xe9 },
	{ (void*)CpuExecCb0xea },
	{ (void*)CpuExecCb0xeb },
	{ (void*)CpuExecCb0xec },
	{ (void*)CpuExecCb0xed },
	{ (void*)CpuExecCb0xee },
	{ (void*)CpuExecCb0xef },
	{ (void*)CpuExecCb0xf0 },
	{ (void*)CpuExecCb0xf1 },
	{ (void*)CpuExecCb0xf2 },
	{ (void*)CpuExecCb0xf3 },
	{ (void*)CpuExecCb0xf4 },
	{ (void*)CpuExecCb0xf5 },
	{ (void*)CpuExecCb0xf6 },
	{ (void*)CpuExecCb0xf7 },
	{ (void*)CpuExecCb0xf8 },
	{ (void*)CpuExecCb0xf9 },
	{ (void*)CpuExecCb0xfa },
	{ (void*)CpuExecCb0xfb },
	{ (void*)CpuExecCb0xfc },
	{ (void*)CpuExecCb0xfd },
	{ (void*)CpuExecCb0xfe },
	{ (void*)CpuExecCb0xff },
};
//---------------------------------------------------------------------------
extern ST_CPU Cpu;


//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecCb(void)
{
	u8 cb = MemReadByte(Cpu.PC.uw);
	Cpu.PC.uw++;

	CpuExecCbTable[cb].pFunc();
}
//---------------------------------------------------------------------------
// RLC B
IWRAM_CODE void CpuExecCb0x00(void)
{
	Cpu.BC.b.h = CpuExecRlc(Cpu.BC.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RLC C
IWRAM_CODE void CpuExecCb0x01(void)
{
	Cpu.BC.b.l = CpuExecRlc(Cpu.BC.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RLC D
IWRAM_CODE void CpuExecCb0x02(void)
{
	Cpu.DE.b.h = CpuExecRlc(Cpu.DE.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RLC E
IWRAM_CODE void CpuExecCb0x03(void)
{
	Cpu.DE.b.l = CpuExecRlc(Cpu.DE.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RLC H
IWRAM_CODE void CpuExecCb0x04(void)
{
	Cpu.HL.b.h = CpuExecRlc(Cpu.HL.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RLC L
IWRAM_CODE void CpuExecCb0x05(void)
{
	Cpu.HL.b.l = CpuExecRlc(Cpu.HL.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RLC [HL]
IWRAM_CODE void CpuExecCb0x06(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecRlc(MemReadByte(Cpu.HL.uw), FALSE));
}
//---------------------------------------------------------------------------
// RLC A
IWRAM_CODE void CpuExecCb0x07(void)
{
	Cpu.AF.b.h = CpuExecRlc(Cpu.AF.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RRC B
IWRAM_CODE void CpuExecCb0x08(void)
{
	Cpu.BC.b.h = CpuExecRrc(Cpu.BC.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RRC C
IWRAM_CODE void CpuExecCb0x09(void)
{
	Cpu.BC.b.l = CpuExecRrc(Cpu.BC.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RRC D
IWRAM_CODE void CpuExecCb0x0a(void)
{
	Cpu.DE.b.h = CpuExecRrc(Cpu.DE.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RRC E
IWRAM_CODE void CpuExecCb0x0b(void)
{
	Cpu.DE.b.l = CpuExecRrc(Cpu.DE.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RRC H
IWRAM_CODE void CpuExecCb0x0c(void)
{
	Cpu.HL.b.h = CpuExecRrc(Cpu.HL.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RRC L
IWRAM_CODE void CpuExecCb0x0d(void)
{
	Cpu.HL.b.l = CpuExecRrc(Cpu.HL.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RRC [HL]
IWRAM_CODE void CpuExecCb0x0e(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecRrc(MemReadByte(Cpu.HL.uw), FALSE));
}
//---------------------------------------------------------------------------
// RRC A
IWRAM_CODE void CpuExecCb0x0f(void)
{
	Cpu.AF.b.h = CpuExecRrc(Cpu.AF.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RL B
IWRAM_CODE void CpuExecCb0x10(void)
{
	Cpu.BC.b.h = CpuExecRl(Cpu.BC.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RL C
IWRAM_CODE void CpuExecCb0x11(void)
{
	Cpu.BC.b.l = CpuExecRl(Cpu.BC.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RL D
IWRAM_CODE void CpuExecCb0x12(void)
{
	Cpu.DE.b.h = CpuExecRl(Cpu.DE.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RL E
IWRAM_CODE void CpuExecCb0x13(void)
{
	Cpu.DE.b.l = CpuExecRl(Cpu.DE.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RL H
IWRAM_CODE void CpuExecCb0x14(void)
{
	Cpu.HL.b.h = CpuExecRl(Cpu.HL.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RL L
IWRAM_CODE void CpuExecCb0x15(void)
{
	Cpu.HL.b.l = CpuExecRl(Cpu.HL.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RL [HL]
IWRAM_CODE void CpuExecCb0x16(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecRl(MemReadByte(Cpu.HL.uw), FALSE));
}
//---------------------------------------------------------------------------
// RL A
IWRAM_CODE void CpuExecCb0x17(void)
{
	Cpu.AF.b.h = CpuExecRl(Cpu.AF.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RR B
IWRAM_CODE void CpuExecCb0x18(void)
{
	Cpu.BC.b.h = CpuExecRr(Cpu.BC.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RR C
IWRAM_CODE void CpuExecCb0x19(void)
{
	Cpu.BC.b.l = CpuExecRr(Cpu.BC.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RR D
IWRAM_CODE void CpuExecCb0x1a(void)
{
	Cpu.DE.b.h = CpuExecRr(Cpu.DE.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RR E
IWRAM_CODE void CpuExecCb0x1b(void)
{
	Cpu.DE.b.l = CpuExecRr(Cpu.DE.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RR H
IWRAM_CODE void CpuExecCb0x1c(void)
{
	Cpu.HL.b.h = CpuExecRr(Cpu.HL.b.h, FALSE);
}
//---------------------------------------------------------------------------
// RR L
IWRAM_CODE void CpuExecCb0x1d(void)
{
	Cpu.HL.b.l = CpuExecRr(Cpu.HL.b.l, FALSE);
}
//---------------------------------------------------------------------------
// RR [HL]
IWRAM_CODE void CpuExecCb0x1e(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecRr(MemReadByte(Cpu.HL.uw), FALSE));
}
//---------------------------------------------------------------------------
// RR A
IWRAM_CODE void CpuExecCb0x1f(void)
{
	Cpu.AF.b.h = CpuExecRr(Cpu.AF.b.h, FALSE);
}
//---------------------------------------------------------------------------
// SLA B
IWRAM_CODE void CpuExecCb0x20(void)
{
	Cpu.BC.b.h = CpuExecSla(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// SLA C
IWRAM_CODE void CpuExecCb0x21(void)
{
	Cpu.BC.b.l = CpuExecSla(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// SLA D
IWRAM_CODE void CpuExecCb0x22(void)
{
	Cpu.DE.b.h = CpuExecSla(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// SLA E
IWRAM_CODE void CpuExecCb0x23(void)
{
	Cpu.DE.b.l = CpuExecSla(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// SLA H
IWRAM_CODE void CpuExecCb0x24(void)
{
	Cpu.HL.b.h = CpuExecSla(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// SLA L
IWRAM_CODE void CpuExecCb0x25(void)
{
	Cpu.HL.b.l = CpuExecSla(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// SLA [HL]
IWRAM_CODE void CpuExecCb0x26(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecSla(MemReadByte(Cpu.HL.uw)));
}
//---------------------------------------------------------------------------
// SLA A
IWRAM_CODE void CpuExecCb0x27(void)
{
	Cpu.AF.b.h = CpuExecSla(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// SRA B
IWRAM_CODE void CpuExecCb0x28(void)
{
	Cpu.BC.b.h = CpuExecSra(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// SRA C
IWRAM_CODE void CpuExecCb0x29(void)
{
	Cpu.BC.b.l = CpuExecSra(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// SRA D
IWRAM_CODE void CpuExecCb0x2a(void)
{
	Cpu.DE.b.h = CpuExecSra(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// SRA E
IWRAM_CODE void CpuExecCb0x2b(void)
{
	Cpu.DE.b.l = CpuExecSra(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// SRA H
IWRAM_CODE void CpuExecCb0x2c(void)
{
	Cpu.HL.b.h = CpuExecSra(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// SRA L
IWRAM_CODE void CpuExecCb0x2d(void)
{
	Cpu.HL.b.l = CpuExecSra(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// SRA [HL]
IWRAM_CODE void CpuExecCb0x2e(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecSra(MemReadByte(Cpu.HL.uw)));
}
//---------------------------------------------------------------------------
// SRA A
IWRAM_CODE void CpuExecCb0x2f(void)
{
	Cpu.AF.b.h = CpuExecSra(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// SWAP B
IWRAM_CODE void CpuExecCb0x30(void)
{
	Cpu.BC.b.h = CpuExecSwap(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// SWAP C
IWRAM_CODE void CpuExecCb0x31(void)
{
	Cpu.BC.b.l = CpuExecSwap(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// SWAP D
IWRAM_CODE void CpuExecCb0x32(void)
{
	Cpu.DE.b.h = CpuExecSwap(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// SWAP E
IWRAM_CODE void CpuExecCb0x33(void)
{
	Cpu.DE.b.l = CpuExecSwap(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// SWAP H
IWRAM_CODE void CpuExecCb0x34(void)
{
	Cpu.HL.b.h = CpuExecSwap(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// SWAP L
IWRAM_CODE void CpuExecCb0x35(void)
{
	Cpu.HL.b.l = CpuExecSwap(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// SWAP [HL]
IWRAM_CODE void CpuExecCb0x36(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecSwap(MemReadByte(Cpu.HL.uw)));
}
//---------------------------------------------------------------------------
// SWAP A
IWRAM_CODE void CpuExecCb0x37(void)
{
	Cpu.AF.b.h = CpuExecSwap(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// SRL B
IWRAM_CODE void CpuExecCb0x38(void)
{
	Cpu.BC.b.h = CpuExecSrl(Cpu.BC.b.h);
}
//---------------------------------------------------------------------------
// SRL C
IWRAM_CODE void CpuExecCb0x39(void)
{
	Cpu.BC.b.l = CpuExecSrl(Cpu.BC.b.l);
}
//---------------------------------------------------------------------------
// SRL D
IWRAM_CODE void CpuExecCb0x3a(void)
{
	Cpu.DE.b.h = CpuExecSrl(Cpu.DE.b.h);
}
//---------------------------------------------------------------------------
// SRL E
IWRAM_CODE void CpuExecCb0x3b(void)
{
	Cpu.DE.b.l = CpuExecSrl(Cpu.DE.b.l);
}
//---------------------------------------------------------------------------
// SRL H
IWRAM_CODE void CpuExecCb0x3c(void)
{
	Cpu.HL.b.h = CpuExecSrl(Cpu.HL.b.h);
}
//---------------------------------------------------------------------------
// SRL L
IWRAM_CODE void CpuExecCb0x3d(void)
{
	Cpu.HL.b.l = CpuExecSrl(Cpu.HL.b.l);
}
//---------------------------------------------------------------------------
// SRL [HL]
IWRAM_CODE void CpuExecCb0x3e(void)
{
	MemWriteByte(Cpu.HL.uw, CpuExecSrl(MemReadByte(Cpu.HL.uw)));
}
//---------------------------------------------------------------------------
// SRL A
IWRAM_CODE void CpuExecCb0x3f(void)
{
	Cpu.AF.b.h = CpuExecSrl(Cpu.AF.b.h);
}
//---------------------------------------------------------------------------
// BIT 0, B
IWRAM_CODE void CpuExecCb0x40(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, C
IWRAM_CODE void CpuExecCb0x41(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, D
IWRAM_CODE void CpuExecCb0x42(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, E
IWRAM_CODE void CpuExecCb0x43(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, H
IWRAM_CODE void CpuExecCb0x44(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, L
IWRAM_CODE void CpuExecCb0x45(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, [HL]
IWRAM_CODE void CpuExecCb0x46(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x01);
}
//---------------------------------------------------------------------------
// BIT 0, A
IWRAM_CODE void CpuExecCb0x47(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x01);
}
//---------------------------------------------------------------------------
// BIT 1, B
IWRAM_CODE void CpuExecCb0x48(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, C
IWRAM_CODE void CpuExecCb0x49(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, D
IWRAM_CODE void CpuExecCb0x4a(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, E
IWRAM_CODE void CpuExecCb0x4b(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, H
IWRAM_CODE void CpuExecCb0x4c(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, L
IWRAM_CODE void CpuExecCb0x4d(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, [HL]
IWRAM_CODE void CpuExecCb0x4e(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x02);
}
//---------------------------------------------------------------------------
// BIT 1, A
IWRAM_CODE void CpuExecCb0x4f(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x02);
}
//---------------------------------------------------------------------------
// BIT 2, B
IWRAM_CODE void CpuExecCb0x50(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, C
IWRAM_CODE void CpuExecCb0x51(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, D
IWRAM_CODE void CpuExecCb0x52(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, E
IWRAM_CODE void CpuExecCb0x53(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, H
IWRAM_CODE void CpuExecCb0x54(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, L
IWRAM_CODE void CpuExecCb0x55(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, [HL]
IWRAM_CODE void CpuExecCb0x56(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x04);
}
//---------------------------------------------------------------------------
// BIT 2, A
IWRAM_CODE void CpuExecCb0x57(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x04);
}
//---------------------------------------------------------------------------
// BIT 3, B
IWRAM_CODE void CpuExecCb0x58(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, C
IWRAM_CODE void CpuExecCb0x59(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, D
IWRAM_CODE void CpuExecCb0x5a(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, E
IWRAM_CODE void CpuExecCb0x5b(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, H
IWRAM_CODE void CpuExecCb0x5c(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, L
IWRAM_CODE void CpuExecCb0x5d(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, [HL]
IWRAM_CODE void CpuExecCb0x5e(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x08);
}
//---------------------------------------------------------------------------
// BIT 3, A
IWRAM_CODE void CpuExecCb0x5f(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x08);
}
//---------------------------------------------------------------------------
// BIT 4, B
IWRAM_CODE void CpuExecCb0x60(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, C
IWRAM_CODE void CpuExecCb0x61(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, D
IWRAM_CODE void CpuExecCb0x62(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, E
IWRAM_CODE void CpuExecCb0x63(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, H
IWRAM_CODE void CpuExecCb0x64(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, L
IWRAM_CODE void CpuExecCb0x65(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, [HL]
IWRAM_CODE void CpuExecCb0x66(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x10);
}
//---------------------------------------------------------------------------
// BIT 4, A
IWRAM_CODE void CpuExecCb0x67(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x10);
}
//---------------------------------------------------------------------------
// BIT 5, B
IWRAM_CODE void CpuExecCb0x68(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, C
IWRAM_CODE void CpuExecCb0x69(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, D
IWRAM_CODE void CpuExecCb0x6a(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, E
IWRAM_CODE void CpuExecCb0x6b(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, H
IWRAM_CODE void CpuExecCb0x6c(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, L
IWRAM_CODE void CpuExecCb0x6d(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, [HL]
IWRAM_CODE void CpuExecCb0x6e(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x20);
}
//---------------------------------------------------------------------------
// BIT 5, A
IWRAM_CODE void CpuExecCb0x6f(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x20);
}
//---------------------------------------------------------------------------
// BIT 6, B
IWRAM_CODE void CpuExecCb0x70(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, C
IWRAM_CODE void CpuExecCb0x71(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, D
IWRAM_CODE void CpuExecCb0x72(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, E
IWRAM_CODE void CpuExecCb0x73(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, H
IWRAM_CODE void CpuExecCb0x74(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, L
IWRAM_CODE void CpuExecCb0x75(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, [HL]
IWRAM_CODE void CpuExecCb0x76(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x40);
}
//---------------------------------------------------------------------------
// BIT 6, A
IWRAM_CODE void CpuExecCb0x77(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x40);
}
//---------------------------------------------------------------------------
// BIT 7, B
IWRAM_CODE void CpuExecCb0x78(void)
{
	CpuExecBit(Cpu.BC.b.h & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, C
IWRAM_CODE void CpuExecCb0x79(void)
{
	CpuExecBit(Cpu.BC.b.l & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, D
IWRAM_CODE void CpuExecCb0x7a(void)
{
	CpuExecBit(Cpu.DE.b.h & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, E
IWRAM_CODE void CpuExecCb0x7b(void)
{
	CpuExecBit(Cpu.DE.b.l & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, H
IWRAM_CODE void CpuExecCb0x7c(void)
{
	CpuExecBit(Cpu.HL.b.h & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, L
IWRAM_CODE void CpuExecCb0x7d(void)
{
	CpuExecBit(Cpu.HL.b.l & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, [HL]
IWRAM_CODE void CpuExecCb0x7e(void)
{
	CpuExecBit(MemReadByte(Cpu.HL.uw) & 0x80);
}
//---------------------------------------------------------------------------
// BIT 7, A
IWRAM_CODE void CpuExecCb0x7f(void)
{
	CpuExecBit(Cpu.AF.b.h & 0x80);
}
//---------------------------------------------------------------------------
// RES 0, B
IWRAM_CODE void CpuExecCb0x80(void)
{
	Cpu.BC.b.h &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 0, C
IWRAM_CODE void CpuExecCb0x81(void)
{
	Cpu.BC.b.l &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 0, D
IWRAM_CODE void CpuExecCb0x82(void)
{
	Cpu.DE.b.h &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 0, E
IWRAM_CODE void CpuExecCb0x83(void)
{
	Cpu.DE.b.l &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 0, H
IWRAM_CODE void CpuExecCb0x84(void)
{
	Cpu.HL.b.h &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 0, L
IWRAM_CODE void CpuExecCb0x85(void)
{
	Cpu.HL.b.l &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 0, [HL]
IWRAM_CODE void CpuExecCb0x86(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x01));
}
//---------------------------------------------------------------------------
// RES 0, A
IWRAM_CODE void CpuExecCb0x87(void)
{
	Cpu.AF.b.h &= (~0x01);
}
//---------------------------------------------------------------------------
// RES 1, B
IWRAM_CODE void CpuExecCb0x88(void)
{
	Cpu.BC.b.h &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 1, C
IWRAM_CODE void CpuExecCb0x89(void)
{
	Cpu.BC.b.l &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 1, D
IWRAM_CODE void CpuExecCb0x8a(void)
{
	Cpu.DE.b.h &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 1, E
IWRAM_CODE void CpuExecCb0x8b(void)
{
	Cpu.DE.b.l &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 1, H
IWRAM_CODE void CpuExecCb0x8c(void)
{
	Cpu.HL.b.h &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 1, L
IWRAM_CODE void CpuExecCb0x8d(void)
{
	Cpu.HL.b.l &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 1, [HL]
IWRAM_CODE void CpuExecCb0x8e(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x02));
}
//---------------------------------------------------------------------------
// RES 1, A
IWRAM_CODE void CpuExecCb0x8f(void)
{
	Cpu.AF.b.h &= (~0x02);
}
//---------------------------------------------------------------------------
// RES 2, B
IWRAM_CODE void CpuExecCb0x90(void)
{
	Cpu.BC.b.h &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 2, C
IWRAM_CODE void CpuExecCb0x91(void)
{
	Cpu.BC.b.l &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 2, D
IWRAM_CODE void CpuExecCb0x92(void)
{
	Cpu.DE.b.h &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 2, E
IWRAM_CODE void CpuExecCb0x93(void)
{
	Cpu.DE.b.l &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 2, H
IWRAM_CODE void CpuExecCb0x94(void)
{
	Cpu.HL.b.h &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 2, L
IWRAM_CODE void CpuExecCb0x95(void)
{
	Cpu.HL.b.l &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 2, [HL]
IWRAM_CODE void CpuExecCb0x96(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x04));
}
//---------------------------------------------------------------------------
// RES 2, A
IWRAM_CODE void CpuExecCb0x97(void)
{
	Cpu.AF.b.h &= (~0x04);
}
//---------------------------------------------------------------------------
// RES 3, B
IWRAM_CODE void CpuExecCb0x98(void)
{
	Cpu.BC.b.h &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 3, C
IWRAM_CODE void CpuExecCb0x99(void)
{
	Cpu.BC.b.l &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 3, D
IWRAM_CODE void CpuExecCb0x9a(void)
{
	Cpu.DE.b.h &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 3, E
IWRAM_CODE void CpuExecCb0x9b(void)
{
	Cpu.DE.b.l &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 3, H
IWRAM_CODE void CpuExecCb0x9c(void)
{
	Cpu.HL.b.h &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 3, L
IWRAM_CODE void CpuExecCb0x9d(void)
{
	Cpu.HL.b.l &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 3, [HL]
IWRAM_CODE void CpuExecCb0x9e(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x08));
}
//---------------------------------------------------------------------------
// RES 3, A
IWRAM_CODE void CpuExecCb0x9f(void)
{
	Cpu.AF.b.h &= (~0x08);
}
//---------------------------------------------------------------------------
// RES 4, B
IWRAM_CODE void CpuExecCb0xa0(void)
{
	Cpu.BC.b.h &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 4, C
IWRAM_CODE void CpuExecCb0xa1(void)
{
	Cpu.BC.b.l &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 4, D
IWRAM_CODE void CpuExecCb0xa2(void)
{
	Cpu.DE.b.h &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 4, E
IWRAM_CODE void CpuExecCb0xa3(void)
{
	Cpu.DE.b.l &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 4, H
IWRAM_CODE void CpuExecCb0xa4(void)
{
	Cpu.HL.b.h &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 4, L
IWRAM_CODE void CpuExecCb0xa5(void)
{
	Cpu.HL.b.l &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 4, [HL]
IWRAM_CODE void CpuExecCb0xa6(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x10));
}
//---------------------------------------------------------------------------
// RES 4, A
IWRAM_CODE void CpuExecCb0xa7(void)
{
	Cpu.AF.b.h &= (~0x10);
}
//---------------------------------------------------------------------------
// RES 5, B
IWRAM_CODE void CpuExecCb0xa8(void)
{
	Cpu.BC.b.h &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 5, C
IWRAM_CODE void CpuExecCb0xa9(void)
{
	Cpu.BC.b.l &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 5, D
IWRAM_CODE void CpuExecCb0xaa(void)
{
	Cpu.DE.b.h &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 5, E
IWRAM_CODE void CpuExecCb0xab(void)
{
	Cpu.DE.b.l &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 5, H
IWRAM_CODE void CpuExecCb0xac(void)
{
	Cpu.HL.b.h &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 5, L
IWRAM_CODE void CpuExecCb0xad(void)
{
	Cpu.HL.b.l &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 5, [HL]
IWRAM_CODE void CpuExecCb0xae(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x20));
}
//---------------------------------------------------------------------------
// RES 5, A
IWRAM_CODE void CpuExecCb0xaf(void)
{
	Cpu.AF.b.h &= (~0x20);
}
//---------------------------------------------------------------------------
// RES 6, B
IWRAM_CODE void CpuExecCb0xb0(void)
{
	Cpu.BC.b.h &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 6, C
IWRAM_CODE void CpuExecCb0xb1(void)
{
	Cpu.BC.b.l &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 6, D
IWRAM_CODE void CpuExecCb0xb2(void)
{
	Cpu.DE.b.h &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 6, E
IWRAM_CODE void CpuExecCb0xb3(void)
{
	Cpu.DE.b.l &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 6, H
IWRAM_CODE void CpuExecCb0xb4(void)
{
	Cpu.HL.b.h &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 6, L
IWRAM_CODE void CpuExecCb0xb5(void)
{
	Cpu.HL.b.l &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 6, [HL]
IWRAM_CODE void CpuExecCb0xb6(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x40));
}
//---------------------------------------------------------------------------
// RES 6, A
IWRAM_CODE void CpuExecCb0xb7(void)
{
	Cpu.AF.b.h &= (~0x40);
}
//---------------------------------------------------------------------------
// RES 7, B
IWRAM_CODE void CpuExecCb0xb8(void)
{
	Cpu.BC.b.h &= (~0x80);
}
//---------------------------------------------------------------------------
// RES 7, C
IWRAM_CODE void CpuExecCb0xb9(void)
{
	Cpu.BC.b.l &= (~0x80);
}
//---------------------------------------------------------------------------
// RES 7, D
IWRAM_CODE void CpuExecCb0xba(void)
{
	Cpu.DE.b.h &= (~0x80);
}
//---------------------------------------------------------------------------
// RES 7, E
IWRAM_CODE void CpuExecCb0xbb(void)
{
	Cpu.DE.b.l &= (~0x80);
}
//---------------------------------------------------------------------------
// RES 7, H
IWRAM_CODE void CpuExecCb0xbc(void)
{
	Cpu.HL.b.h &= (~0x80);
}
//---------------------------------------------------------------------------
// RES 7, L
IWRAM_CODE void CpuExecCb0xbd(void)
{
	Cpu.HL.b.l &= (~0x80);
}
//---------------------------------------------------------------------------
// RES 7, [HL]
IWRAM_CODE void CpuExecCb0xbe(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) & (~0x80));
}
//---------------------------------------------------------------------------
// RES 7, A
IWRAM_CODE void CpuExecCb0xbf(void)
{
	Cpu.AF.b.h &= (~0x80);
}
//---------------------------------------------------------------------------
// SET 0, B
IWRAM_CODE void CpuExecCb0xc0(void)
{
	Cpu.BC.b.h |= 0x01;
}
//---------------------------------------------------------------------------
// SET 0, C
IWRAM_CODE void CpuExecCb0xc1(void)
{
	Cpu.BC.b.l |= 0x01;
}
//---------------------------------------------------------------------------
// SET 0, D
IWRAM_CODE void CpuExecCb0xc2(void)
{
	Cpu.DE.b.h |= 0x01;
}
//---------------------------------------------------------------------------
// SET 0, E
IWRAM_CODE void CpuExecCb0xc3(void)
{
	Cpu.DE.b.l |= 0x01;
}
//---------------------------------------------------------------------------
// SET 0, H
IWRAM_CODE void CpuExecCb0xc4(void)
{
	Cpu.HL.b.h |= 0x01;
}
//---------------------------------------------------------------------------
// SET 0, L
IWRAM_CODE void CpuExecCb0xc5(void)
{
	Cpu.HL.b.l |= 0x01;
}
//---------------------------------------------------------------------------
// SET 0, [HL]
IWRAM_CODE void CpuExecCb0xc6(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x01);
}
//---------------------------------------------------------------------------
// SET 0, A
IWRAM_CODE void CpuExecCb0xc7(void)
{
	Cpu.AF.b.h |= 0x01;
}
//---------------------------------------------------------------------------
// SET 1, B
IWRAM_CODE void CpuExecCb0xc8(void)
{
	Cpu.BC.b.h |= 0x02;
}
//---------------------------------------------------------------------------
// SET 1, C
IWRAM_CODE void CpuExecCb0xc9(void)
{
	Cpu.BC.b.l |= 0x02;
}
//---------------------------------------------------------------------------
// SET 1, D
IWRAM_CODE void CpuExecCb0xca(void)
{
	Cpu.DE.b.h |= 0x02;
}
//---------------------------------------------------------------------------
// SET 1, E
IWRAM_CODE void CpuExecCb0xcb(void)
{
	Cpu.DE.b.l |= 0x02;
}
//---------------------------------------------------------------------------
// SET 1, H
IWRAM_CODE void CpuExecCb0xcc(void)
{
	Cpu.HL.b.h |= 0x02;
}
//---------------------------------------------------------------------------
// SET 1, L
IWRAM_CODE void CpuExecCb0xcd(void)
{
	Cpu.HL.b.l |= 0x02;
}
//---------------------------------------------------------------------------
// SET 1, [HL]
IWRAM_CODE void CpuExecCb0xce(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x02);
}
//---------------------------------------------------------------------------
// SET 1, A
IWRAM_CODE void CpuExecCb0xcf(void)
{
	Cpu.AF.b.h |= 0x02;
}
//---------------------------------------------------------------------------
// SET 2, B
IWRAM_CODE void CpuExecCb0xd0(void)
{
	Cpu.BC.b.h |= 0x04;
}
//---------------------------------------------------------------------------
// SET 2, C
IWRAM_CODE void CpuExecCb0xd1(void)
{
	Cpu.BC.b.l |= 0x04;
}
//---------------------------------------------------------------------------
// SET 2, D
IWRAM_CODE void CpuExecCb0xd2(void)
{
	Cpu.DE.b.h |= 0x04;
}
//---------------------------------------------------------------------------
// SET 2, E
IWRAM_CODE void CpuExecCb0xd3(void)
{
	Cpu.DE.b.l |= 0x04;
}
//---------------------------------------------------------------------------
// SET 2, H
IWRAM_CODE void CpuExecCb0xd4(void)
{
	Cpu.HL.b.h |= 0x04;
}
//---------------------------------------------------------------------------
// SET 2, L
IWRAM_CODE void CpuExecCb0xd5(void)
{
	Cpu.HL.b.l |= 0x04;
}
//---------------------------------------------------------------------------
// SET 2, [HL]
IWRAM_CODE void CpuExecCb0xd6(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x04);
}
//---------------------------------------------------------------------------
// SET 2, A
IWRAM_CODE void CpuExecCb0xd7(void)
{
	Cpu.AF.b.h |= 0x04;
}
//---------------------------------------------------------------------------
// SET 3, B
IWRAM_CODE void CpuExecCb0xd8(void)
{
	Cpu.BC.b.h |= 0x08;
}
//---------------------------------------------------------------------------
// SET 3, C
IWRAM_CODE void CpuExecCb0xd9(void)
{
	Cpu.BC.b.l |= 0x08;
}
//---------------------------------------------------------------------------
// SET 3, D
IWRAM_CODE void CpuExecCb0xda(void)
{
	Cpu.DE.b.h |= 0x08;
}
//---------------------------------------------------------------------------
// SET 3, E
IWRAM_CODE void CpuExecCb0xdb(void)
{
	Cpu.DE.b.l |= 0x08;
}
//---------------------------------------------------------------------------
// SET 3, H
IWRAM_CODE void CpuExecCb0xdc(void)
{
	Cpu.HL.b.h |= 0x08;
}
//---------------------------------------------------------------------------
// SET 3, L
IWRAM_CODE void CpuExecCb0xdd(void)
{
	Cpu.HL.b.l |= 0x08;
}
//---------------------------------------------------------------------------
// SET 3, [HL]
IWRAM_CODE void CpuExecCb0xde(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x08);
}
//---------------------------------------------------------------------------
// SET 3, A
IWRAM_CODE void CpuExecCb0xdf(void)
{
	Cpu.AF.b.h |= 0x08;
}
//---------------------------------------------------------------------------
// SET 4, B
IWRAM_CODE void CpuExecCb0xe0(void)
{
	Cpu.BC.b.h |= 0x10;
}
//---------------------------------------------------------------------------
// SET 4, C
IWRAM_CODE void CpuExecCb0xe1(void)
{
	Cpu.BC.b.l |= 0x10;
}
//---------------------------------------------------------------------------
// SET 4, D
IWRAM_CODE void CpuExecCb0xe2(void)
{
	Cpu.DE.b.h |= 0x10;
}
//---------------------------------------------------------------------------
// SET 4, E
IWRAM_CODE void CpuExecCb0xe3(void)
{
	Cpu.DE.b.l |= 0x10;
}
//---------------------------------------------------------------------------
// SET 4, H
IWRAM_CODE void CpuExecCb0xe4(void)
{
	Cpu.HL.b.h |= 0x10;
}
//---------------------------------------------------------------------------
// SET 4, L
IWRAM_CODE void CpuExecCb0xe5(void)
{
	Cpu.HL.b.l |= 0x10;
}
//---------------------------------------------------------------------------
// SET 4, [HL]
IWRAM_CODE void CpuExecCb0xe6(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x10);
}
//---------------------------------------------------------------------------
// SET 4, A
IWRAM_CODE void CpuExecCb0xe7(void)
{
	Cpu.AF.b.h |= 0x10;
}
//---------------------------------------------------------------------------
// SET 5, B
IWRAM_CODE void CpuExecCb0xe8(void)
{
	Cpu.BC.b.h |= 0x20;
}
//---------------------------------------------------------------------------
// SET 5, C
IWRAM_CODE void CpuExecCb0xe9(void)
{
	Cpu.BC.b.l |= 0x20;
}
//---------------------------------------------------------------------------
// SET 5, D
IWRAM_CODE void CpuExecCb0xea(void)
{
	Cpu.DE.b.h |= 0x20;
}
//---------------------------------------------------------------------------
// SET 5, E
IWRAM_CODE void CpuExecCb0xeb(void)
{
	Cpu.DE.b.l |= 0x20;
}
//---------------------------------------------------------------------------
// SET 5, H
IWRAM_CODE void CpuExecCb0xec(void)
{
	Cpu.HL.b.h |= 0x20;
}
//---------------------------------------------------------------------------
// SET 5, L
IWRAM_CODE void CpuExecCb0xed(void)
{
	Cpu.HL.b.l |= 0x20;
}
//---------------------------------------------------------------------------
// SET 5, [HL]
IWRAM_CODE void CpuExecCb0xee(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x20);
}
//---------------------------------------------------------------------------
// SET 5, A
IWRAM_CODE void CpuExecCb0xef(void)
{
	Cpu.AF.b.h |= 0x20;
}
//---------------------------------------------------------------------------
// SET 6, B
IWRAM_CODE void CpuExecCb0xf0(void)
{
	Cpu.BC.b.h |= 0x40;
}
//---------------------------------------------------------------------------
// SET 6, C
IWRAM_CODE void CpuExecCb0xf1(void)
{
	Cpu.BC.b.l |= 0x40;
}
//---------------------------------------------------------------------------
// SET 6, D
IWRAM_CODE void CpuExecCb0xf2(void)
{
	Cpu.DE.b.h |= 0x40;
}
//---------------------------------------------------------------------------
// SET 6, E
IWRAM_CODE void CpuExecCb0xf3(void)
{
	Cpu.DE.b.l |= 0x40;
}
//---------------------------------------------------------------------------
// SET 6, H
IWRAM_CODE void CpuExecCb0xf4(void)
{
	Cpu.HL.b.h |= 0x40;
}
//---------------------------------------------------------------------------
// SET 6, L
IWRAM_CODE void CpuExecCb0xf5(void)
{
	Cpu.HL.b.l |= 0x40;
}
//---------------------------------------------------------------------------
// SET 6, [HL]
IWRAM_CODE void CpuExecCb0xf6(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x40);
}
//---------------------------------------------------------------------------
// SET 6, A
IWRAM_CODE void CpuExecCb0xf7(void)
{
	Cpu.AF.b.h |= 0x40;
}
//---------------------------------------------------------------------------
// SET 7, B
IWRAM_CODE void CpuExecCb0xf8(void)
{
	Cpu.BC.b.h |= 0x80;
}
//---------------------------------------------------------------------------
// SET 7, C
IWRAM_CODE void CpuExecCb0xf9(void)
{
	Cpu.BC.b.l |= 0x80;
}
//---------------------------------------------------------------------------
// SET 7, D
IWRAM_CODE void CpuExecCb0xfa(void)
{
	Cpu.DE.b.h |= 0x80;
}
//---------------------------------------------------------------------------
// SET 7, E
IWRAM_CODE void CpuExecCb0xfb(void)
{
	Cpu.DE.b.l |= 0x80;
}
//---------------------------------------------------------------------------
// SET 7, H
IWRAM_CODE void CpuExecCb0xfc(void)
{
	Cpu.HL.b.h |= 0x80;
}
//---------------------------------------------------------------------------
// SET 7, L
IWRAM_CODE void CpuExecCb0xfd(void)
{
	Cpu.HL.b.l |= 0x80;
}
//---------------------------------------------------------------------------
// SET 7, [HL]
IWRAM_CODE void CpuExecCb0xfe(void)
{
	MemWriteByte(Cpu.HL.uw, MemReadByte(Cpu.HL.uw) | 0x80);
}
//---------------------------------------------------------------------------
// SET 7, A
IWRAM_CODE void CpuExecCb0xff(void)
{
	Cpu.AF.b.h |= 0x80;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecRlc(u8 r, bool isRegisterA)
{
	u8 result = r;

	if((result & 0x80) != 0)
	{
		CpuFlagSet(CPU_FLAG_CARRY);
		result <<= 1;
		result |= 0x1;
	}
	else
	{
		CpuFlagClearAll();
		result <<= 1;
    }

	if(!isRegisterA)
	{
		CpuFlagToggleZeroFromResult(result);
	}

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecRrc(u8 r, bool isRegisterA)
{
	u8 result = r;

	if((result & 0x01) != 0)
	{
		CpuFlagSet(CPU_FLAG_CARRY);
		result >>= 1;
		result |= 0x80;
	}
	else
	{
		CpuFlagClearAll();
		result >>= 1;
	}

	if(!isRegisterA)
	{
		CpuFlagToggleZeroFromResult(result);
	}

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecRl(u8 r, bool isRegisterA)
{
	u8 carry = CpuFlagIsSet(CPU_FLAG_CARRY) ? 1 : 0;
	u8 result = r;

	((result & 0x80) != 0) ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();
	result <<= 1;
	result |= carry;

	if(!isRegisterA)
	{
		CpuFlagToggleZeroFromResult(result);
	}

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecRr(u8 r, bool isRegisterA)
{
	u8 carry = CpuFlagIsSet(CPU_FLAG_CARRY) ? 0x80 : 0x00;
	u8 result = r;

	((result & 0x01) != 0) ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();
	result >>= 1;
	result |= carry;

	if(!isRegisterA)
	{
		CpuFlagToggleZeroFromResult(result);
	}

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecSla(u8 r)
{
	(r & 0x80) != 0 ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();

	u8 result = r << 1;
	CpuFlagToggleZeroFromResult(result);

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecSra(u8 r)
{
	u8 result = r;
	(result & 0x01) != 0 ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();

	if((result & 0x80) != 0)
	{
		result >>= 1;
		result |= 0x80;
	}
	else
	{
		result >>= 1;
	}

	CpuFlagToggleZeroFromResult(result);

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecSwap(u8 r)
{
	u8 low_half  = r & 0x0f;
	u8 high_half = (r >> 4) & 0x0f;

	u8 result = (low_half << 4) + high_half;

	CpuFlagClearAll();
	CpuFlagToggleZeroFromResult(result);

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 CpuExecSrl(u8 r)
{
	u8 result = r;
	(result & 0x01) != 0 ? CpuFlagSet(CPU_FLAG_CARRY) : CpuFlagClearAll();

	result >>= 1;
	CpuFlagToggleZeroFromResult(result);

	return result;
}
//---------------------------------------------------------------------------
IWRAM_CODE void CpuExecBit(u8 r)
{
	if(r == 0)
	{
		CpuFlagToggle(CPU_FLAG_ZERO);
	}
	else
	{
		CpuFlagUnToggle(CPU_FLAG_ZERO);
	}

	CpuFlagToggle(CPU_FLAG_HALF);
	CpuFlagUnToggle(CPU_FLAG_SUB);
}
