#ifndef GBS_H
#define GBS_H
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

typedef struct {
	char sig[3];			// "GBS"
	u8   ver;				// Version(1)
	u8   numSong;			// Number of songs(1 - 255)
	u8   firstSong;			// First song(usually 1)
	u16  adrLoad;			// Load address ($400-$7fff)
	u16  adrInit;			// Init address ($400-$7fff)
	u16  adrPlay;			// Play address ($400-$7fff)
	u16  adrStack;			// Stack pointer
	u8   tma;				// Timer modulo
	u8   tac;				// Timer control
	u8   title[32];			// Title string
	u8   author[32];		// Author string
	char copyright[32];		// Copyright string
} __PACKED ST_GBS_HEADER;


typedef struct {
	u32 maxFile;
	u32 maxSong;

	u32 fileNum;
	u32 songNum;

	u32 select;

} ST_GBS;


//---------------------------------------------------------------------------
EWRAM_CODE void GbsInit(void);
IWRAM_CODE void GbsExec(void);
IWRAM_CODE void GbsExecFile(void);
IWRAM_CODE void GbsExecSong(void);
IWRAM_CODE void GbsDraw(void);

IWRAM_CODE void GbsPlay(void);
IWRAM_CODE void GbsStop(void);

IWRAM_CODE void GbsSetTiming(u8 tmc, u8 tma);
IWRAM_CODE void GbsSetSong(void);

#ifdef __cplusplus
}
#endif
#endif
