#include "lib/gba.h"
#include "irq_arm.h"
#include "bg.h"
#include "key.h"

#include "cpu.h"
#include "mem.h"
#include "gbs.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
IWRAM_CODE int main(void)
{
	REG_WSCNT = 0x4317;

	GbfsInit();
	IrqInit();
	BgInit();
	KeyInit();

	CpuInit();
	MemInit();
	GbsInit();

	for(;;)
	{
		VBlankIntrWait();

		GbsDraw();

		KeyExec();
		GbsExec();
	}
}
