#ifndef MEM_H
#define MEM_H
#ifdef __cplusplus
extern "C" {
#endif

#include "lib/gba.h"


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
typedef struct {
	u8  mem[0x10000];

	u8* pRom1;
	u32 rom1Num;
	u32 rom1Offset;

} ST_MEM;


//---------------------------------------------------------------------------
EWRAM_CODE void MemInit(void);
EWRAM_CODE void MemLoadGbs(u8* pCode, u16 adrLoad);
EWRAM_CODE void MemLoadRom0(u8* pCode, u16 adrLoad);
IWRAM_CODE void MemLoadRom1(u8 byte);

IWRAM_CODE void MemWriteByte(u16 adr, u8 byte);
IWRAM_CODE void MemWriteWord(u16 adr, u16 word);
IWRAM_CODE void MemWriteIO(u8 adr8, u8 byte);


// fobOɕKvȏꍇ̂ݎgp܂
// IWRAM_CODE u8   MemReadByte(u16 adr);
// IWRAM_CODE u16  MemReadWord(u16 adr);


#define MemReadByte(adr)			(Mem.mem[adr])
#define MemReadWord(adr)			(Mem.mem[adr] + (Mem.mem[adr + 1] << 8))
extern ST_MEM Mem;


#ifdef __cplusplus
}
#endif
#endif
